/*
*  Rubrica
*  file: dialoghi.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "dialoghi.h"
#include "support.h"


void
info (void)
{
  const gchar *authors[] = {
   _("Nicola Fragale <nicolafragale@libero.it>"),
    NULL
  };
  GtkWidget *about1;

  about1 = gnome_about_new ("Rubrica", VERSION,
			    _("Copyrigth (C) 2000-2001 Nicola Fragale "),
			    authors,    
			    _("A Gnome Address book\nhttp://digilander.iol.it/nfragale"),
			    NULL);

  gtk_object_set_data (GTK_OBJECT (about1), "about1", about1);
  gtk_container_set_border_width (GTK_CONTAINER (about1), 5);
  gtk_window_set_modal (GTK_WINDOW (about1), TRUE);
  
  gtk_signal_connect (GTK_OBJECT (about1), "clicked",
                      GTK_SIGNAL_FUNC (gtk_widget_destroy),
                      NULL);

  gtk_widget_show(about1);
}


void
dedica (void)
{
  GtkWidget *messagebox1;
  GtkWidget *dialog_vbox1;
  GtkWidget *button6;

  messagebox1 = gnome_message_box_new (_("This program is dedicate to...\n\nmy mother\nmy father\nmy girl friend\nmy brothers\nmy relatives\nmy friends\n\nan affectionate memory for my uncle\nwho isn't more with us"),
				       GNOME_MESSAGE_BOX_GENERIC, NULL);

  gtk_object_set_data (GTK_OBJECT (messagebox1), "messagebox1", messagebox1);
  gtk_container_set_border_width (GTK_CONTAINER (messagebox1), 6);
  gtk_window_set_modal (GTK_WINDOW (messagebox1), TRUE);
  gtk_window_set_title (GTK_WINDOW (messagebox1), _("Info"));

  gtk_window_set_position (GTK_WINDOW (messagebox1), GTK_WIN_POS_CENTER);

  dialog_vbox1 = GNOME_DIALOG (messagebox1)->vbox;
  gtk_widget_show (dialog_vbox1);

  gnome_dialog_append_button (GNOME_DIALOG (messagebox1), 
			      GNOME_STOCK_BUTTON_OK);
  button6 = g_list_last (GNOME_DIALOG (messagebox1)->buttons)->data;
  gtk_widget_show (button6);
  GTK_WIDGET_SET_FLAGS (button6, GTK_CAN_DEFAULT);

  gtk_widget_show(messagebox1);
}


void
calabria (void)
{
  GtkWidget *dialogo_calabria;
  GtkWidget *dialog_vbox1;
  GtkWidget *hbox1;
  gchar *pixmap1_filename;
  GtkWidget *pixmap1;
  GtkWidget *vseparator1;
  GtkWidget *frame_calabria;
  GtkWidget *label1;
  GtkWidget *dialog_action_area1;
  GtkWidget *button4;

  dialogo_calabria = gnome_dialog_new (_("Calabria"), NULL);
  gtk_object_set_data (GTK_OBJECT (dialogo_calabria), "dialogo_calabria",
		       dialogo_calabria);
  gtk_container_set_border_width (GTK_CONTAINER (dialogo_calabria), 5);
  gtk_window_set_modal (GTK_WINDOW (dialogo_calabria), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dialogo_calabria), FALSE, FALSE, FALSE);
  gnome_dialog_set_close (GNOME_DIALOG (dialogo_calabria), TRUE);

  dialog_vbox1 = GNOME_DIALOG (dialogo_calabria)->vbox;
  gtk_widget_show (dialog_vbox1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), hbox1, TRUE, TRUE, 0);

  pixmap1 = gtk_type_new (gnome_pixmap_get_type ());
  pixmap1_filename = 
    gnome_pixmap_file ("rubrica/calabria.xpm");
  if (pixmap1_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (pixmap1), pixmap1_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "calabria.xpm");
  g_free (pixmap1_filename);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox1), pixmap1, TRUE, TRUE, 0);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, FALSE, FALSE, 5);

  frame_calabria = gtk_frame_new (_(" Calabria "));
  gtk_widget_show (frame_calabria);
  gtk_box_pack_start (GTK_BOX (hbox1), frame_calabria, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame_calabria), 5);

  label1 = gtk_label_new (_("\"\n\t\t\tQuando fu il giorno della Calabria, Dio si trov in pugno 15.000 chilometri quadrati di argilla verde con riflessi viola. Il Signore promise a Se Stesso di farne un capolavoro e la Calabria usc dalle Sue mani pi bella della California e delle Haway, pi bella della Costa Azzurra e degli Arcipelaghi giapponesi. Diede alla Sila il pino, all'Aspromonte l'ulivo, a Rosarno l'arancio, a Scilla le Sirene, a Bagnara i pergolati, allo scoglio il lichene, all'onda il riflesso del sole, alla roccia l'oleastro, a Gioia l'olio, a Cosenza l'Accademia, a Catanzaro il damasco, a Reggio il bergamotto, allo Stretto il pescespada. Poi distribu i mesi e le stagioni alla Calabria. Per l'inverno le fu concesso il sole, per la primavera il sole, per l'autunno il sole...\nA gennaio diede la castagna, a febraio la pignolata, a marzo la ricotta, ad aprile la focaccia con l'uovo, a maggio il pescespada, a giugno la ciliegia, a luglio il ficomelanzano, ad agosto lo zibibbo, a settembre il ficodindia, ad ottobre la mostarda, a novembre la noce, a dicembre l'arancia. Volle il mare sempre viola, la rosa sbocciante a dicembre, il cielo terso, le campagne fertili, le messi pingui, il clima mite, il profumo delle erbe inebriante...\t\t\"\n\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tLeonida Rpaci\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t Rubbettino Editore\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t http://www.rubbettino.it\n"));

  gtk_widget_show (label1);
  gtk_container_add (GTK_CONTAINER (frame_calabria), label1);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_FILL);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);
  gtk_misc_set_padding (GTK_MISC (label1), 15, 2);

  dialog_action_area1 = GNOME_DIALOG (dialogo_calabria)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), 
			     GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);

  gnome_dialog_append_button (GNOME_DIALOG (dialogo_calabria), 
			      GNOME_STOCK_BUTTON_OK);
  button4 = g_list_last (GNOME_DIALOG (dialogo_calabria)->buttons)->data;
  gtk_widget_show (button4);
  GTK_WIDGET_SET_FLAGS (button4, GTK_CAN_DEFAULT);

  gtk_widget_show(dialogo_calabria);
}


gint confirm_delete(gchar *messaggio)
{
  GtkWidget *dialogo, *label;
  gint bottone;

  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_YES,
			     GNOME_STOCK_BUTTON_NO, NULL);
  label = gtk_label_new(messaggio);
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, 
		     TRUE, 0);
  
  bottone = gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));

  return bottone;
}


gint confirm_file_close(gchar *messaggio)
{
  GtkWidget *dialogo, *label;
  gint bottone;

  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_YES,
			     GNOME_STOCK_BUTTON_NO, NULL);  
  label = gtk_label_new(messaggio);
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, 
		     TRUE, 0);
  
  bottone = gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));

  return bottone;
}

gint confirm_exit(gchar *messaggio)
{
  GtkWidget *dialogo, *label;
  gint bottone;

  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_YES,
			     GNOME_STOCK_BUTTON_NO, NULL);  
  label = gtk_label_new(messaggio);
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, 
		     TRUE, 0);
  
  bottone = gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));

  return bottone;
}

/*    Ajout par Francois Massonneau le 20/05/2001
 */
void
afaire (void)
{
  GtkWidget *messagebox1;
  GtkWidget *dialog_vbox1;
  GtkWidget *button_afaire;

  messagebox1 = gnome_message_box_new (_("Some functions could still not working"),
				       GNOME_MESSAGE_BOX_GENERIC, NULL);

  gtk_container_set_border_width (GTK_CONTAINER (messagebox1), 6);
  gtk_window_set_modal (GTK_WINDOW (messagebox1), TRUE);
  gtk_window_set_title (GTK_WINDOW (messagebox1), _("Not working"));

  gtk_window_set_position (GTK_WINDOW (messagebox1), GTK_WIN_POS_CENTER);

  dialog_vbox1 = GNOME_DIALOG (messagebox1)->vbox;
  gtk_widget_show (dialog_vbox1);

  gnome_dialog_append_button (GNOME_DIALOG (messagebox1), 
			      GNOME_STOCK_BUTTON_OK);
  button_afaire = g_list_last (GNOME_DIALOG (messagebox1)->buttons)->data;
  gtk_widget_show (button_afaire);
  GTK_WIDGET_SET_FLAGS (button_afaire, GTK_CAN_DEFAULT);

  gtk_widget_show(messagebox1);
}

/*  Fin de l'ajout par Francois Massonneau le 20/05/2001
 */


void
create_bug_dialog (void)
{
  GtkWidget *bug_dialog;
  GtkWidget *dialog_bug;
  GtkWidget *bug_frame;
  GtkWidget *hbox1;
  gchar *pixmap1_filename;
  GtkWidget *pixmap1;
  GtkWidget *vseparator1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *hseparator1;
  GtkWidget *href1;
  GtkWidget *dialog_action_area1;
  GtkWidget *button3;

  bug_dialog = gnome_dialog_new (_("If you found a bug"), NULL);
  gtk_object_set_data (GTK_OBJECT (bug_dialog), "bug_dialog", bug_dialog);
  gtk_container_set_border_width (GTK_CONTAINER (bug_dialog), 5);
  GTK_WINDOW (bug_dialog)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (bug_dialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (bug_dialog), TRUE);
  gtk_window_set_policy (GTK_WINDOW (bug_dialog), FALSE, FALSE, FALSE);

  dialog_bug = GNOME_DIALOG (bug_dialog)->vbox;
  gtk_widget_show (dialog_bug);

  bug_frame = gtk_frame_new (_(" Bugs "));
  gtk_widget_show (bug_frame);
  gtk_box_pack_start (GTK_BOX (dialog_bug), bug_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bug_frame), 5);

  hbox1 = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (bug_frame), hbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 5);

  pixmap1 = gtk_type_new (gnome_pixmap_get_type ());
  pixmap1_filename = gnome_pixmap_file ("rubrica/bug.png");
  if (pixmap1_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (pixmap1), pixmap1_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "bug.png");
  g_free (pixmap1_filename);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox1), pixmap1, TRUE, TRUE, 0);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, TRUE, TRUE, 0);

  vbox1 = gtk_vbox_new (FALSE, 5);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 5);

  label1 = gtk_label_new (_("If you found a bug in rubrica\nplease, send me an email with\na bug description.\nOr, better, if rubrica crashes,\na bug-buddy report.\nThanks"));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, TRUE, TRUE, 0);

  href1 = gnome_href_new ("mailto:nicolafragale@libero.it", _("email me"));
  gtk_widget_ref (href1);
  gtk_object_set_data_full (GTK_OBJECT (bug_dialog), "href1", href1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (href1);
  gtk_box_pack_start (GTK_BOX (vbox1), href1, FALSE, FALSE, 0);

  dialog_action_area1 = GNOME_DIALOG (bug_dialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (bug_dialog), "dialog_action_area1", 
		       dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);

  gnome_dialog_append_button (GNOME_DIALOG (bug_dialog), GNOME_STOCK_BUTTON_CLOSE);
  button3 = GTK_WIDGET (g_list_last (GNOME_DIALOG (bug_dialog)->buttons)->data);
  gtk_widget_show (button3);
  GTK_WIDGET_SET_FLAGS (button3, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (bug_dialog), "delete_event",
                      GTK_SIGNAL_FUNC (gtk_widget_destroy),
                      bug_dialog);
  gtk_signal_connect_object (GTK_OBJECT (button3), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     (gpointer) bug_dialog);
  
  gtk_widget_show(bug_dialog);
}


void
create_email_dialog (void)
{
  GtkWidget *email_dialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *frame1;
  GtkWidget *hbox1;
  gchar *pixmap1_filename;
  GtkWidget *pixmap1;
  GtkWidget *vseparator1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *hseparator1;
  GtkWidget *href1;
  GtkWidget *dialog_action_area1;
  GtkWidget *button3;

  email_dialog = gnome_dialog_new (_("Email me"), NULL);
  gtk_object_set_data (GTK_OBJECT (email_dialog), "email_dialog", email_dialog);
  gtk_container_set_border_width (GTK_CONTAINER (email_dialog), 5);
  GTK_WINDOW (email_dialog)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (email_dialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (email_dialog), TRUE);
  gtk_window_set_policy (GTK_WINDOW (email_dialog), FALSE, FALSE, FALSE);

  dialog_vbox1 = GNOME_DIALOG (email_dialog)->vbox;
  gtk_widget_show (dialog_vbox1);

  frame1 = gtk_frame_new (_(" Email me "));
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 5);

  hbox1 = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (frame1), hbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 5);

  pixmap1 = gtk_type_new (gnome_pixmap_get_type ());
  pixmap1_filename = gnome_pixmap_file ("rubrica/word.png");
  if (pixmap1_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (pixmap1), pixmap1_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "word.png");
  g_free (pixmap1_filename);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox1), pixmap1, TRUE, TRUE, 0);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, TRUE, TRUE, 0);

  vbox1 = gtk_vbox_new (FALSE, 5);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 5);

  label1 = gtk_label_new (_("Click button \nif you want email me"));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, TRUE, TRUE, 0);

  href1 = gnome_href_new ("mailto:nicolafragale@libero.it", "Nicola Fragale");
  gtk_widget_ref (href1);
  gtk_object_set_data_full (GTK_OBJECT (email_dialog), "href1", href1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (href1);
  gtk_box_pack_start (GTK_BOX (vbox1), href1, FALSE, FALSE, 0);

  dialog_action_area1 = GNOME_DIALOG (email_dialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (email_dialog), "dialog_action_area1", 
		       dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);

  gnome_dialog_append_button (GNOME_DIALOG (email_dialog), GNOME_STOCK_BUTTON_CLOSE);
  button3 = GTK_WIDGET (g_list_last (GNOME_DIALOG (email_dialog)->buttons)->data);
  gtk_widget_show (button3);
  GTK_WIDGET_SET_FLAGS (button3, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (email_dialog), "delete_event",
                      GTK_SIGNAL_FUNC (gtk_widget_destroy),
                      email_dialog);
  gtk_signal_connect_object (GTK_OBJECT (button3), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     (gpointer) email_dialog);

  gtk_widget_show(email_dialog);
}

void
create_homepage (void)
{
  GtkWidget *homepage;
  GtkWidget *dialog_vbox3;
  GtkWidget *frame2;
  GtkWidget *hbox1;
  gchar *pixmap1_filename;
  GtkWidget *pixmap1;
  GtkWidget *vseparator1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *hseparator1;
  GtkWidget *href1;
  GtkWidget *dialog_action_area1;
  GtkWidget *button7;

  homepage = gnome_dialog_new (_("Rubrica home page"), NULL);
  gtk_object_set_data (GTK_OBJECT (homepage), "homepage", homepage);
  GTK_WINDOW (homepage)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (homepage), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (homepage), TRUE);
  gtk_window_set_policy (GTK_WINDOW (homepage), FALSE, FALSE, FALSE);

  dialog_vbox3 = GNOME_DIALOG (homepage)->vbox;
  gtk_widget_show (dialog_vbox3);

  frame2 = gtk_frame_new (_(" Home page "));
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), frame2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 5);

  hbox1 = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (frame2), hbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 5);

  pixmap1 = gtk_type_new (gnome_pixmap_get_type ());
  pixmap1_filename = gnome_pixmap_file ("rubrica/casa.png");
  if (pixmap1_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (pixmap1), pixmap1_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "casa.png");
  g_free (pixmap1_filename);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox1), pixmap1, TRUE, TRUE, 0);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, TRUE, TRUE, 0);

  vbox1 = gtk_vbox_new (FALSE, 5);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 5);

  label1 = gtk_label_new (_("Click button to go \nto rubrica home page"));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, TRUE, TRUE, 0);

  href1 = gnome_href_new ("http://digilander.iol.it/nfragale", _("Rubrica home page"));
  gtk_widget_ref (href1);
  gtk_object_set_data_full (GTK_OBJECT (homepage), "href1", href1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (href1);
  gtk_box_pack_start (GTK_BOX (vbox1), href1, FALSE, FALSE, 0);

  dialog_action_area1 = GNOME_DIALOG (homepage)->action_area;
  gtk_object_set_data (GTK_OBJECT (homepage), "dialog_action_area1",
		       dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);

  gnome_dialog_append_button (GNOME_DIALOG (homepage), GNOME_STOCK_BUTTON_CLOSE);
  button7 = GTK_WIDGET (g_list_last (GNOME_DIALOG (homepage)->buttons)->data);
  gtk_widget_show (button7);
  GTK_WIDGET_SET_FLAGS (button7, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (homepage), "delete_event",
                      GTK_SIGNAL_FUNC (gtk_widget_destroy),
                      homepage);
  gtk_signal_connect_object (GTK_OBJECT (button7), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     (gpointer) homepage);
  gtk_widget_show(homepage);
}


void 
create_tododialog (void)
{
  GtkWidget *tododialog;
  GtkWidget *todovbox;
  GtkWidget *hbox1;
  gchar *pixmap1_filename;
  GtkWidget *pixmap1;
  GtkWidget *vseparator1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *dialog_action_area1;
  GtkWidget *button5;

  tododialog = gnome_dialog_new (_("Rubrica will have"), NULL);
  gtk_object_set_data (GTK_OBJECT (tododialog), "tododialog", tododialog);
  gtk_container_set_border_width (GTK_CONTAINER (tododialog), 5);
  GTK_WINDOW (tododialog)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (tododialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (tododialog), TRUE);
  gtk_window_set_policy (GTK_WINDOW (tododialog), FALSE, FALSE, FALSE);

  todovbox = GNOME_DIALOG (tododialog)->vbox;
  gtk_widget_show (todovbox);

  hbox1 = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (todovbox), hbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 5);

  pixmap1 = gtk_type_new (gnome_pixmap_get_type ());
  pixmap1_filename = gnome_pixmap_file ("rubrica/devel.png");
  if (pixmap1_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (pixmap1), pixmap1_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "devel.png");
  g_free (pixmap1_filename);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox1), pixmap1, TRUE, TRUE, 0);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, TRUE, TRUE, 0);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox1, TRUE, TRUE, 0);

  label1 = gtk_label_new (_("Next tools:\n\nimport from Kab\nimport from netscape csv\nexport addressbook to html (with xsl)\n\nand...\nI'm waiting your suggestion ;-)"));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);

  dialog_action_area1 = GNOME_DIALOG (tododialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (tododialog), "dialog_action_area1", 
		       dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);

  gnome_dialog_append_button (GNOME_DIALOG (tododialog), GNOME_STOCK_BUTTON_CLOSE);
  button5 = GTK_WIDGET (g_list_last (GNOME_DIALOG (tododialog)->buttons)->data);
  gtk_widget_show (button5);
  GTK_WIDGET_SET_FLAGS (button5, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (tododialog), "delete_event",
                      GTK_SIGNAL_FUNC (gtk_widget_destroy),
                      tododialog);

  gtk_signal_connect_object (GTK_OBJECT (button5), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     (gpointer) tododialog);
  gtk_widget_show(tododialog);
}


void
create_help_me (void)
{
  GtkWidget *help_me;
  GtkWidget *dialog_vbox1;
  GtkWidget *button1;

  /* We create it with an OK button, and then remove the button, to work
     around a bug in gnome-libs. */
  help_me = gnome_message_box_new (_("Rubrica needs localization.\nPlease, if your language isn't supported,\ntranslate rubrica."),
                              GNOME_MESSAGE_BOX_INFO,
                              GNOME_STOCK_BUTTON_OK, NULL);
  gtk_container_remove (GTK_CONTAINER (GNOME_DIALOG (help_me)->action_area), 
			GNOME_DIALOG (help_me)->buttons->data);
  GNOME_DIALOG (help_me)->buttons = NULL;
  gtk_window_set_title (GTK_WINDOW (help_me), _("Info"));
  gtk_window_set_policy (GTK_WINDOW (help_me), FALSE, FALSE, FALSE);

  dialog_vbox1 = GNOME_DIALOG (help_me)->vbox;
  gtk_widget_show (dialog_vbox1);

  gnome_dialog_append_button (GNOME_DIALOG (help_me), GNOME_STOCK_BUTTON_OK);
  button1 = GTK_WIDGET (g_list_last (GNOME_DIALOG (help_me)->buttons)->data);
  gtk_widget_show (button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  gtk_widget_show(help_me);
}

