/*
*  Rubrica
*  file: file.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _RUBRICA_DICT_H
#define _RUBRICA_DICT_H

#include <gnome.h>
#include <gconf/gconf-client.h>

typedef enum {
  ITALIAN = 0,
  ENGLISH,
  USER, 
  UNKNOWN
} LANG;

typedef enum {
  CARD = 0,
  DELETING, MODIFYING, CREATED, LAST_CHANGE, 
  DATA, ADDRESS, COMPANY, WORK,
  FIRST_NAME, MIDDLE_NAME, LAST_NAME, PROFESSION, NAME_PREFIX, TITLE,
  STREET, STREET_NUMBER, ZIP_CODE, CITY, PROVINCE, STATE, COUNTRY, 
  WEB_ADDRESS, WEB, EMAIL_ADDRESS, EMAIL, 
  TELEPHONE_NUMBERS, TELEPHONE, TYPE, 
  COMPANY_NAME, OPERATOR, FAX, GREEN, CUSTOMER_CARE,
  ASSIGMENT, ORGANIZATION, DEPARTMENT, SUB_DEPARTMENT, 
  SECRETARY, SECRETARY_PHONE, 
  SPOUSE, MARRIED, ANNIVERSARY, CHILDREN, CHILDREN_NOTES, 
  HOBBIES, NOTE, PUBLIC_KEY, 
  BIRTHDAY, CARD_NAME, OTHER_NOTE,   
  END
} TCODE;

 
typedef gchar RubricaDictionary;

void rubrica_dictionary_init(LANG language);

gboolean rubrica_dictionary_load_user_dictionary(GConfClient* client);
gboolean rubrica_dictionary_save_user_dictionary(GConfClient *client, 
						 gchar *language);
void rubrica_dictionary_parse_node(GConfClient* client, xmlNodePtr node);
void rubrica_dictionary_display_dictionary(GtkWidget *prefbox, 
					   GConfClient* client);

void rubrica_dictionary_get_italian(void);
void rubrica_dictionary_get_english(void);
void rubrica_dictionary_get_user_dictionary(void);
gboolean rubrica_dictionary_get(LANG language);



#endif
