/*
*  Rubrica
*  file: druid_int.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <gnome.h>

#include "druid_cb.h"
#include "prefer.h"
#include "support.h"

GtkWidget* rubrica_druid_create_druid (void)
{
  GtkWidget *druid;
  GtkWidget *druid1;
  GtkWidget *druidpagestart1;

  GdkColor druidpagestart1_bg_color = { 0, 6425, 6425, 28784 };
  GdkColor druidpagestart1_textbox_color = { 0, 65535, 65535, 65535 };
  GdkColor druidpagestart1_logo_bg_color = { 0, 65535, 65535, 65535 };
  GdkColor druidpagestart1_title_color = { 0, 65535, 65535, 65535 };
  GtkWidget *druidpagestandard1;
  GdkColor druidpagestandard1_bg_color = { 0, 6425, 6425, 28784 };
  GdkColor druidpagestandard1_logo_bg_color = { 0, 65535, 65535, 65535 };
  GdkColor druidpagestandard1_title_color = { 0, 65535, 65535, 65535 };
  GtkWidget *druid_vbox1;
  GtkWidget *vbox1;
  GtkWidget *book_frame;
  GtkWidget *vbox2;
  GtkWidget *frame2;
  GtkWidget *vbox3;

  GtkWidget *check_book;
  GtkWidget *check_folder;

  GtkWidget *fileentry1;
  GtkWidget *fileentry2;
  GtkWidget *entry_book;
  GtkWidget *entry_folder;

  GtkWidget *druidpagefinish1;

  gchar *home, *addressbook, *folder;

  GdkColor druidpagefinish1_bg_color = { 0, 6425, 6425, 28784 };
  GdkColor druidpagefinish1_textbox_color = { 0, 65535, 65535, 65535 };
  GdkColor druidpagefinish1_logo_bg_color = { 0, 65535, 65535, 65535 };
  GdkColor druidpagefinish1_title_color = { 0, 65535, 65535, 65535 };


  druid = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_ref (druid);
  gtk_window_set_title (GTK_WINDOW (druid), _("First rubrica configuration"));

  druid1 = gnome_druid_new ();
  gtk_object_set_data_full (GTK_OBJECT (druid), "druid1", druid1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (druid1);
  gtk_container_add (GTK_CONTAINER (druid), druid1);

  druidpagestart1 = gnome_druid_page_start_new ();
  gtk_widget_ref (druidpagestart1);
  gtk_object_set_data_full (GTK_OBJECT (druid), "druidpagestart1", druidpagestart1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (druidpagestart1);
  gnome_druid_append_page (GNOME_DRUID (druid1), GNOME_DRUID_PAGE (druidpagestart1));
  gnome_druid_set_page (GNOME_DRUID (druid1), GNOME_DRUID_PAGE (druidpagestart1));
  gnome_druid_page_start_set_bg_color (GNOME_DRUID_PAGE_START (druidpagestart1),
				       &druidpagestart1_bg_color);
  gnome_druid_page_start_set_textbox_color (GNOME_DRUID_PAGE_START (druidpagestart1), 
					    &druidpagestart1_textbox_color);
  gnome_druid_page_start_set_logo_bg_color (GNOME_DRUID_PAGE_START (druidpagestart1), 
					    &druidpagestart1_logo_bg_color);
  gnome_druid_page_start_set_title_color (GNOME_DRUID_PAGE_START (druidpagestart1),
					  &druidpagestart1_title_color);
  gnome_druid_page_start_set_title (GNOME_DRUID_PAGE_START (druidpagestart1), 
				    _("Rubrica Configuration"));
  gnome_druid_page_start_set_text (GNOME_DRUID_PAGE_START (druidpagestart1), 
				   _("It seem the first time that you run Rubrica.\nClick on Next to configure rubrica"));
  gnome_druid_page_start_set_logo (GNOME_DRUID_PAGE_START (druidpagestart1),
                                   create_image ("rubrica/rubrica.jpg"));

  druidpagestandard1 = gnome_druid_page_standard_new_with_vals ("", NULL);
  gtk_widget_ref (druidpagestandard1);
  gtk_widget_show_all (druidpagestandard1);
  gnome_druid_append_page (GNOME_DRUID (druid1), GNOME_DRUID_PAGE(druidpagestandard1));
  gnome_druid_page_standard_set_bg_color(GNOME_DRUID_PAGE_STANDARD(druidpagestandard1),
					 &druidpagestandard1_bg_color);
  gnome_druid_page_standard_set_logo_bg_color(GNOME_DRUID_PAGE_STANDARD
					      (druidpagestandard1), 
					      &druidpagestandard1_logo_bg_color);
  gnome_druid_page_standard_set_title_color (GNOME_DRUID_PAGE_STANDARD 
					     (druidpagestandard1), 
					     &druidpagestandard1_title_color);
  gnome_druid_page_standard_set_logo (GNOME_DRUID_PAGE_STANDARD (druidpagestandard1),
                                      create_image ("rubrica/rubrica.jpg"));

  druid_vbox1 = GNOME_DRUID_PAGE_STANDARD (druidpagestandard1)->vbox;
  gtk_widget_show (druid_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (druid_vbox1), vbox1, TRUE, TRUE, 0);

  book_frame = gtk_frame_new (_(" Default address book "));
  gtk_widget_show (book_frame);
  gtk_box_pack_start (GTK_BOX (vbox1), book_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (book_frame), 3);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (book_frame), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 5);

  check_book = gtk_check_button_new_with_label 
    (_("Rubrica will load this addressbook at start"));
  gtk_widget_ref (check_book);
  gtk_object_set_data_full (GTK_OBJECT (druid), "check_book", check_book,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (check_book);
  gtk_box_pack_start (GTK_BOX (vbox2), check_book, FALSE, FALSE, 0);

  fileentry1 = gnome_file_entry_new (NULL, NULL);
  gtk_widget_ref (fileentry1);
  gtk_object_set_data_full (GTK_OBJECT (druid), "fileentry1", fileentry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fileentry1);
  gtk_box_pack_start (GTK_BOX (vbox2), fileentry1, FALSE, FALSE, 0);

  home = g_get_home_dir();
  addressbook = g_strdup_printf("%s/.rubrica/rubrica.rub", home);
  entry_book = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (fileentry1)); 
  gtk_object_set_data (GTK_OBJECT (druid), "entry_book", entry_book); 
  gtk_entry_set_text (GTK_ENTRY (entry_book), addressbook);
  rubrica_preferences_set_book(addressbook);
  gtk_widget_show (entry_book);

  frame2 = gtk_frame_new (_(" Default folder "));
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox1), frame2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 3);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (frame2), vbox3);
  gtk_container_set_border_width (GTK_CONTAINER (vbox3), 5);

  check_folder = gtk_check_button_new_with_label 
    (_("Rubrica will save addressbooks in this folder"));
  gtk_widget_ref (check_folder);
  gtk_object_set_data (GTK_OBJECT (druid), "check_folder", check_folder);
  gtk_widget_show (check_folder);
  gtk_box_pack_start (GTK_BOX (vbox3), check_folder, FALSE, FALSE, 0);

  fileentry2 = gnome_file_entry_new (NULL, NULL);
  gtk_widget_ref (fileentry2);
  gtk_object_set_data_full (GTK_OBJECT (druid), "fileentry2", fileentry2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fileentry2);
  gtk_box_pack_start (GTK_BOX (vbox3), fileentry2, FALSE, FALSE, 0);

  folder = g_strdup_printf("%s/.rubrica", home);
  entry_folder = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (fileentry2));
  gtk_object_set_data (GTK_OBJECT (druid), "enrty_folder", entry_folder);
  gtk_entry_set_text (GTK_ENTRY (entry_folder), folder);
  rubrica_preferences_set_folder(folder);
  gtk_widget_show (entry_folder);

  druidpagefinish1 = gnome_druid_page_finish_new ();
  gtk_widget_ref (druidpagefinish1);
  gtk_object_set_data_full (GTK_OBJECT (druid), "druidpagefinish1", druidpagefinish1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (druidpagefinish1);
  gnome_druid_append_page (GNOME_DRUID (druid1), GNOME_DRUID_PAGE (druidpagefinish1));
  gnome_druid_page_finish_set_bg_color (GNOME_DRUID_PAGE_FINISH (druidpagefinish1), 
					&druidpagefinish1_bg_color);
  gnome_druid_page_finish_set_textbox_color (GNOME_DRUID_PAGE_FINISH 
					     (druidpagefinish1), 
					     &druidpagefinish1_textbox_color);
  gnome_druid_page_finish_set_logo_bg_color (GNOME_DRUID_PAGE_FINISH 
					     (druidpagefinish1), 
					     &druidpagefinish1_logo_bg_color);
  gnome_druid_page_finish_set_title_color (GNOME_DRUID_PAGE_FINISH (druidpagefinish1),
					   &druidpagefinish1_title_color);
  gnome_druid_page_finish_set_text (GNOME_DRUID_PAGE_FINISH (druidpagefinish1), 
				    _("Click on end to finish"));
  gnome_druid_page_finish_set_logo (GNOME_DRUID_PAGE_FINISH (druidpagefinish1),
				    create_image ("rubrica/rubrica.jpg"));

  gtk_signal_connect (GTK_OBJECT (druidpagefinish1), "finish",
                      GTK_SIGNAL_FUNC (on_druidpagefinish1_finish),
                      druid);

  gtk_signal_connect (GTK_OBJECT (druidpagestandard1), "cancel",
                      GTK_SIGNAL_FUNC (on_druidpage_cancel),
                      druid);
  gtk_signal_connect (GTK_OBJECT (druidpagestart1), "cancel",
                      GTK_SIGNAL_FUNC (on_druidpage_cancel),
                      druid);  
  gtk_signal_connect (GTK_OBJECT (druidpagefinish1), "cancel",
                      GTK_SIGNAL_FUNC (on_druidpage_cancel),
                      druid);
  
  gtk_signal_connect (GTK_OBJECT (check_book), "toggled",
                      GTK_SIGNAL_FUNC (on_check_book_toggled),
                      fileentry1);
  gtk_signal_connect (GTK_OBJECT (entry_book), "activate",
                      GTK_SIGNAL_FUNC (on_entry_book_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (entry_book), "changed",
                      GTK_SIGNAL_FUNC (on_entry_book_changed),
                      NULL);
  
  gtk_signal_connect (GTK_OBJECT (check_folder), "toggled",
                      GTK_SIGNAL_FUNC (on_check_folder_toggled),
                      fileentry2);  
  gtk_signal_connect (GTK_OBJECT (entry_folder), "activate",
                      GTK_SIGNAL_FUNC (on_entry_folder_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (entry_folder), "changed",
                      GTK_SIGNAL_FUNC (on_entry_folder_changed),
                      NULL);

  return druid;
}

