/*
*  Rubrica
*  file: error.h
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _RUBRICA_ERROR_H
#define _RUBRICA_ERROR_H

typedef enum {
  RUBRICA_ERROR_FILE_NOT_EXIST = 0,
  RUBRICA_ERROR_NO_XML_DOC,
  RUBRICA_ERROR_PARSE_XML_DOC,
  RUBRICA_ERROR_XML_DOC_NO_RUBRICA_HEADER,
  RUBRICA_ERROR_XML_DOC_NO_RUBRICA_FIELD,
  RUBRICA_ERROR_BAD_MODULE,
  RUBRICA_ERROR_MODULE_IS_NULL,
  RUBRICA_ERROR_NO_ITEM_MODULE,
  RUBRICA_ERROR_NO_ERROR
} RUBRICA_ERROR;

void error_preferences_key(gchar *str);
void error_preferences_key_load(gchar **buffer);
void rubrica_error_selezionare_elemento(void);
void rubrica_error_file(void);
void rubrica_error_cancellazione(void);
void rubrica_error_modifica(void);
void rubrica_error_rubrica_empty(void);
void rubrica_error_no_item_found(void);
void rubrica_error_no_string(void);
void rubrica_error_import_no_file(void);
void rubrica_error_generic(gchar *str);

void rubrica_error_display_error(GtkWidget *parent, gchar* file, RUBRICA_ERROR err);

void rubrica_non_implementato(void);

void rubrica_message(gchar *str);

#endif  
