/*
*  Rubrica
*  file: import_gcard.h
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _IMPORT_GCARD_H
#define _IMPORT_GCARD_H

#include "rubrica.h"

typedef enum {
  BEGIN = 0,
  FN,   N,
  REV,
  BDAY,
  ADR,  TEL,  EMAIL, URL, TZ, GEO,
  TITLE,  ORG, 
  CATEGORIES,  NOTE,
  KEY,
  END,
  BAD
} TokenGCard;

typedef enum {
  VCARD = 0,
  HOME,  WORK, POSTAL, PARCEL, DOM, INTL, PREF,
  VOICE, FAX, MSG, CELL, PAGER, BBS, MODEM, CAR, ISDN, VIDEO,  
  AOL, INTERNET, APPLELINK, ATTMAIL, CIS, EWORLD, IBMMail, MCIMAIL, 
  POWERSHARE, PRODIGY, TLX, X400, PGP, X509, 
  QUOTED_PRINTABLE,
  NO_SUB,  SUB_BAD, SUB_END
} SubGToken;


typedef struct _token {
  gchar *str;
  TokenGCard tok;
  gboolean subtok;
} GToken;

typedef struct _subtoken {
  gchar *str;
  SubGToken stok;
} SubGtoken;


TokenGCard rubrica_import_gcard_get_token(gchar *tkbuf);
gchar *rubrica_import_gcard_get_string(gchar *buf);

TokenGCard rubrica_import_gcard_decode_token(gchar *str, SubGToken *st);
SubGToken rubrica_import_gcard_decode_subtoken(gchar *str);

void rubrica_import_gcard_decode_string(char *buf, gchar *dec[7]);
void rubrica_import_gcard_decode_buffer(gchar *buf);
gchar *rubrica_import_gcard_decode_note(GList *l, gchar *s);


gchar *rubrica_import_gcard_merge_note(GList *l1, GList *l2, gint len1, gint len2);
void rubrica_import_gcard_split_buffer(gchar *buf, gchar **s, gchar **dt, 
				       gboolean *fl);

void rubrica_import_gcard_free_note(GList *n);
void rubrica_import_gcard_clean_buffer(gchar *buffer, gboolean *fl);

time_t rubrica_import_gcard_decode_date(gchar *date, gboolean has_hour);

#endif
