/*
*  Rubrica
*  file: modulo_int.c
*
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "modulo_cb.h"
#include "modulo.h"
#include "support.h"

/*
  Nota:
  le clist web e mail hanno 2 colonne
*/

GtkWidget*
modulo_rubrica_crea_pagina_dati(ModuloRubrica *modulo)
{
  GtkWidget *data_frame;

  /*    entry
   */
  GtkWidget *card_deleting_button;
  GtkWidget *card_modifying_button;

  GtkWidget *card_entry;

  GtkWidget *first_name_entry;
  GtkWidget *middle_name_entry;
  GtkWidget *last_name_entry;

  GtkWidget *profession_entry;
  GtkWidget *name_prefix_entry;
  GtkWidget *title_entry;
  GtkWidget *birthday_check;
  GtkWidget *birthday_dateedit;

  GtkWidget *street_entry;
  GtkWidget *street_num_entry;
  GtkWidget *zip_code_entry;
  GtkWidget *city_entry;
  GtkWidget *province_entry;
  GtkWidget *state_entry;
  GtkWidget *country_entry;
  /* ******************************** */

  GtkWidget *card_frame;
  GtkWidget *name_frame;
  GtkWidget *address_frame;

  GtkWidget *data_box;
  GtkWidget *card_box;
  GtkWidget *card_name_box;
  GtkWidget *card_button_box;
  GtkWidget *name_pixmap_box;
  GtkWidget *name_box;
  GtkWidget *address_box;
  GtkWidget *address_pixmap_box;

  GtkWidget *name_table;
  GtkWidget *address_table;

  GtkWidget *card_label;
  GtkWidget *middle_name_label;
  GtkWidget *last_name_label;
  GtkWidget *profession_label;
  GtkWidget *title_label;
  GtkWidget *name_prefix_label;
  GtkWidget *first_name_label;
  GtkWidget *street_label;
  GtkWidget *number_label;
  GtkWidget *zip_code_label;
  GtkWidget *city_label;
  GtkWidget *province_label;
  GtkWidget *state_label;
  GtkWidget *country_label;

  GtkWidget *card_pixmap;
  GtkWidget *name_pixmap;
  GtkWidget *address_pixmap;
  gchar *card_pixmap_filename;
  gchar *name_pixmap_filename;
  gchar *address_pixmap_filename;


  data_frame = gtk_frame_new (_(" Personal Data"));
  gtk_object_set_data_full (GTK_OBJECT (modulo), "data_frame", data_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (data_frame), 2);
  gtk_widget_show (data_frame);

  data_box = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (data_frame), data_box);
  gtk_container_set_border_width (GTK_CONTAINER (data_box), 2);
  gtk_widget_show (data_box);

  card_frame = gtk_frame_new (_(" Cards "));
  gtk_box_pack_start (GTK_BOX (data_box), card_frame, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (card_frame), 2);
  gtk_widget_show (card_frame);

  card_box = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (card_frame), card_box);
  gtk_container_set_border_width (GTK_CONTAINER (card_box), 2);
  gtk_widget_show (card_box);

  card_name_box = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (card_box), card_name_box, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (card_name_box), 2);
  gtk_widget_show (card_name_box);

  card_label = gtk_label_new (_("Card"));
  gtk_box_pack_start (GTK_BOX (card_name_box), card_label, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (card_label), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (card_label), 10, 0);
  gtk_widget_show (card_label);

  /*    card entry
  */
  card_entry = gtk_entry_new ();
  gtk_widget_ref (card_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "card_entry", card_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (card_name_box), card_entry, TRUE, TRUE, 3);
  gtk_widget_show (card_entry);

  card_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  card_pixmap_filename = gnome_pixmap_file ("rubrica/schede.png");
  if (card_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (card_pixmap), card_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "schede.png");
  g_free (card_pixmap_filename);
  gtk_widget_show (card_pixmap);
  gtk_box_pack_start (GTK_BOX (card_name_box), card_pixmap, FALSE, TRUE, 0);

  card_button_box = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (card_button_box);
  gtk_box_pack_start (GTK_BOX (card_box), card_button_box, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (card_button_box), 2);

  card_deleting_button = gtk_check_button_new_with_label (_("deleting card"));
  gtk_widget_ref (card_deleting_button);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "card_deleting_button", 
			    card_deleting_button,(GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (card_deleting_button);
  gtk_box_pack_start(GTK_BOX (card_button_box), card_deleting_button, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (card_deleting_button), 2);

  card_modifying_button = gtk_check_button_new_with_label (_("modifying card"));
  gtk_widget_ref (card_modifying_button);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "card_modifying_button", 
			    card_modifying_button,(GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (card_modifying_button);
  gtk_box_pack_start(GTK_BOX (card_button_box), card_modifying_button, 
		     FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (card_modifying_button), 2);

  /*    Name Frame
  */
  name_frame = gtk_frame_new (_(" Name "));
  gtk_widget_show (name_frame);
  gtk_box_pack_start (GTK_BOX (data_box), name_frame, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (name_frame), 2);

  name_box = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (name_box);
  gtk_container_add (GTK_CONTAINER (name_frame), name_box);

  name_pixmap_box = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (name_pixmap_box);
  gtk_box_pack_start (GTK_BOX (name_box), name_pixmap_box, TRUE, TRUE, 0);

  name_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  name_pixmap_filename = gnome_pixmap_file ("rubrica/testa.png");
  if (name_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (name_pixmap), name_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "testa.png");
  g_free (name_pixmap_filename);
  gtk_widget_show (name_pixmap);
  gtk_box_pack_start (GTK_BOX (name_pixmap_box), name_pixmap, FALSE, FALSE, 0);

  name_table = gtk_table_new (6, 4, FALSE);
  gtk_widget_show (name_table);
  gtk_box_pack_start (GTK_BOX (name_box), name_table, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (name_table), 2);
  gtk_table_set_row_spacings (GTK_TABLE (name_table), 2);
  gtk_table_set_col_spacings (GTK_TABLE (name_table), 4);

  /*    labels
  */
  first_name_label = gtk_label_new (_("First Name"));
  gtk_widget_show (first_name_label);
  gtk_table_attach (GTK_TABLE (name_table), first_name_label, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (first_name_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (first_name_label), 0, 0.5);

  middle_name_label = gtk_label_new (_("Middle Name"));
  gtk_widget_show (middle_name_label);
  gtk_table_attach (GTK_TABLE (name_table), middle_name_label, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (middle_name_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (middle_name_label), 0, 0.5);

  last_name_label = gtk_label_new (_("Last Name"));
  gtk_widget_show (last_name_label);
  gtk_table_attach (GTK_TABLE (name_table), last_name_label, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (last_name_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (last_name_label), 0, 0.5);

  profession_label = gtk_label_new (_("Profession"));
  gtk_widget_show (profession_label);
  gtk_table_attach (GTK_TABLE (name_table), profession_label, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (profession_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (profession_label), 0, 0.5);

  name_prefix_label = gtk_label_new (_("Name prefix"));
  gtk_widget_show (name_prefix_label);
  gtk_table_attach (GTK_TABLE (name_table), name_prefix_label, 2, 3, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (name_prefix_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (name_prefix_label), 0, 0.5);

  title_label = gtk_label_new (_("Title"));
  gtk_widget_show (title_label);
  gtk_table_attach (GTK_TABLE (name_table), title_label, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (title_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (title_label), 0, 0.5);

  /*    first name entry
  */
  first_name_entry = gtk_entry_new ();
  gtk_widget_ref (first_name_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "first_name_entry", 
			    first_name_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (first_name_entry);
  gtk_table_attach (GTK_TABLE (name_table), first_name_entry, 1, 4, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*     middle name entry
  */
  middle_name_entry = gtk_entry_new ();
  gtk_widget_ref (middle_name_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "middle_name_entry",
			    middle_name_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (middle_name_entry);
  gtk_table_attach (GTK_TABLE (name_table), middle_name_entry, 1, 4, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    last name entry
  */
  last_name_entry = gtk_entry_new ();
  gtk_widget_ref (last_name_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "last_name_entry", 
			    last_name_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (last_name_entry);
  gtk_table_attach (GTK_TABLE (name_table), last_name_entry, 1, 4, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    profession entry
  */
  profession_entry = gtk_entry_new ();
  gtk_widget_ref (profession_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "profession_entry", 
			    profession_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (profession_entry);
  gtk_table_attach (GTK_TABLE (name_table), profession_entry, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    name prefix entry
  */
  name_prefix_entry = gtk_entry_new ();
  gtk_widget_ref (name_prefix_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "name_prefix_entry", 
			    name_prefix_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (name_prefix_entry);
  gtk_table_attach (GTK_TABLE (name_table), name_prefix_entry, 3, 4, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    title entry
  */
  title_entry = gtk_entry_new ();
  gtk_widget_ref (title_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "title_entry", title_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (title_entry);
  gtk_table_attach (GTK_TABLE (name_table), title_entry, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    birthday check button
  */
  birthday_check = gtk_check_button_new_with_label(_("Birthday"));
  gtk_widget_ref (birthday_check);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "birthday_check", birthday_check,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (birthday_check);
  gtk_table_attach (GTK_TABLE (name_table), birthday_check, 2, 3, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    birthday date edit
  */
  birthday_dateedit = gnome_date_edit_new ((time_t) 0, FALSE, FALSE);
  gtk_widget_ref (birthday_dateedit);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "birthday", 
			    birthday_dateedit, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (birthday_dateedit);
  gtk_table_attach (GTK_TABLE (name_table), birthday_dateedit, 3, 4, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    Address Frame
  */
  address_frame = gtk_frame_new (_(" Address "));
  gtk_widget_show (address_frame);
  gtk_box_pack_start (GTK_BOX (data_box), address_frame, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (address_frame), 2);

  address_box = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (address_box);
  gtk_container_add (GTK_CONTAINER (address_frame), address_box);

  address_pixmap_box = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (address_pixmap_box);
  gtk_box_pack_start (GTK_BOX (address_box), address_pixmap_box, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (address_pixmap_box), 2);

  /*    street pixmap 
  */
  address_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  address_pixmap_filename = gnome_pixmap_file ("rubrica/street.png");
  if (address_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (address_pixmap), address_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "street.png");
  g_free (address_pixmap_filename);
  gtk_widget_show (address_pixmap);
  gtk_box_pack_start (GTK_BOX (address_pixmap_box), address_pixmap, FALSE, FALSE, 0);

  address_table = gtk_table_new (5, 4, FALSE);
  gtk_widget_show (address_table);
  gtk_box_pack_start (GTK_BOX (address_box), address_table, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (address_table), 2);
  gtk_table_set_row_spacings (GTK_TABLE (address_table), 2);
  gtk_table_set_col_spacings (GTK_TABLE (address_table), 4);

  /*    labels
  */
  street_label = gtk_label_new (_("Street"));
  gtk_table_attach (GTK_TABLE (address_table), street_label, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (street_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (street_label), 0, 0.5);
  gtk_widget_show (street_label);

  number_label = gtk_label_new (_("Number"));
  gtk_table_attach (GTK_TABLE (address_table), number_label, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (number_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (number_label), 0, 0.5);
  gtk_widget_show (number_label);

  zip_code_label = gtk_label_new (_("Zip Code"));
  gtk_widget_show (zip_code_label);
  gtk_table_attach (GTK_TABLE (address_table), zip_code_label, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (zip_code_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (zip_code_label), 0, 0.5);

  city_label = gtk_label_new (_("City"));
  gtk_widget_show (city_label);
  gtk_table_attach (GTK_TABLE (address_table), city_label, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (city_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (city_label), 0, 0.5);

  province_label = gtk_label_new (_("Province"));
  gtk_widget_show (province_label);
  gtk_table_attach (GTK_TABLE (address_table), province_label, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (province_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (province_label), 0, 0.5);

  state_label = gtk_label_new (_("State"));
  gtk_widget_show (state_label);
  gtk_table_attach (GTK_TABLE (address_table), state_label, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (state_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (state_label), 0, 0.5);

  country_label = gtk_label_new (_("Country"));
  gtk_widget_show (country_label);
  gtk_table_attach (GTK_TABLE (address_table), country_label, 2, 3, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (country_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (country_label), 0, 0.5);

  /*    street entry
  */
  street_entry = gtk_entry_new ();
  gtk_widget_ref (street_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "street_entry", street_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (street_entry);
  gtk_table_attach (GTK_TABLE (address_table), street_entry, 1, 4, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    number entry
  */
  street_num_entry = gtk_entry_new ();
  gtk_widget_ref (street_num_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "street_num_entry", street_num_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (street_num_entry);
  gtk_table_attach (GTK_TABLE (address_table), street_num_entry, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*     zip code entry
  */
  zip_code_entry = gtk_entry_new ();
  gtk_widget_ref (zip_code_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "zip_code_entry", zip_code_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (zip_code_entry);
  gtk_table_attach (GTK_TABLE (address_table), zip_code_entry, 3, 4, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    city entry
  */
  city_entry = gtk_entry_new ();
  gtk_widget_ref (city_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "city_entry", city_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (city_entry);
  gtk_table_attach (GTK_TABLE (address_table), city_entry, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*  province entry
   */
  province_entry = gtk_entry_new ();
  gtk_widget_ref (province_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "province_entry", province_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (province_entry);
  gtk_table_attach (GTK_TABLE (address_table), province_entry, 3, 4, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    state entry
  */
  state_entry = gtk_entry_new ();
  gtk_widget_ref (state_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "state_entry", state_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (state_entry);
  gtk_table_attach (GTK_TABLE (address_table), state_entry, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    country entry
  */
  country_entry = gtk_entry_new ();
  gtk_widget_ref (country_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "country_entry", country_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (country_entry);
  gtk_table_attach (GTK_TABLE (address_table), country_entry, 3, 4, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  

  /*    CALLBACKS
  */

  gtk_signal_connect (GTK_OBJECT (birthday_check), "toggled",
                      GTK_SIGNAL_FUNC (on_check_birthday_toggled),
                      birthday_dateedit);
/*
  gtk_signal_connect (GTK_OBJECT (card_modifying_button), "toggled",
                      GTK_SIGNAL_FUNC (on_check_modificabile_toggled),
                      NULL);
*/

  return data_frame;
}

GtkWidget*
modulo_rubrica_crea_pagina_rete (ModuloRubrica *modulo)
{
  GtkWidget *net_frame;

  GtkWidget *net_box;
  GtkWidget *web_frame;
  GtkWidget *web_box;
  GtkWidget *web_address_box;
  GtkWidget *web_label;
  GtkWidget *web_entry;
  gchar *web_pixmap_filename;
  GtkWidget *web_pixmap;
  GtkWidget *web_list_box;
  GtkWidget *web_buttonbox;
  GtkWidget *web_add;
  GtkWidget *web_modify;
  GtkWidget *web_delete;
  GtkWidget *web_scrollwin;
  GtkWidget *web_clist;
  GtkWidget *web_clist_pix_label;
  GtkWidget *web_clist_address_label;
  GtkWidget *email_frame;
  GtkWidget *email_box;
  GtkWidget *email_address_box;
  GtkWidget *email_label;
  GtkWidget *email_entry;
  gchar *email_pixmap_filename;
  GtkWidget *email_pixmap;
  GtkWidget *email_list_box;
  GtkWidget *email_buttonbox;
  GtkWidget *email_add;
  GtkWidget *email_modify;
  GtkWidget *email_delete;
  GtkWidget *email_scrollwin;
  GtkWidget *email_clist;
  GtkWidget *email_clist_pix_label;
  GtkWidget *email_clist_address_label;

  net_frame = gtk_frame_new (_(" Net Addresses"));
  gtk_object_set_data_full (GTK_OBJECT (modulo), "net_frame", net_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (net_frame), 2);
  gtk_widget_show (net_frame);

  net_box = gtk_vbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (net_frame), net_box);
  gtk_container_set_border_width (GTK_CONTAINER (net_box), 2);
  gtk_widget_show (net_box);

  web_frame = gtk_frame_new (_(" Web "));
  gtk_box_pack_start (GTK_BOX (net_box), web_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (web_frame), 2);
  gtk_widget_show (web_frame);

  web_box = gtk_vbox_new (FALSE, 2);
  gtk_container_add (GTK_CONTAINER (web_frame), web_box);
  gtk_widget_show (web_box);

  web_address_box = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (web_box), web_address_box, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (web_address_box), 2);
  gtk_widget_show (web_address_box);

  web_label = gtk_label_new (_("Web address"));
  gtk_box_pack_start (GTK_BOX (web_address_box), web_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (web_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (web_label), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (web_label), 8, 0);
  gtk_widget_show (web_label);

  /*    web entry
  */
  web_entry = gtk_entry_new ();
  gtk_widget_ref (web_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "web_entry", web_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (web_entry);
  gtk_box_pack_start (GTK_BOX (web_address_box), web_entry, TRUE, TRUE, 0);

  web_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  web_pixmap_filename = gnome_pixmap_file ("rubrica/internet.png");
  if (web_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (web_pixmap), web_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "internet.png");
  g_free (web_pixmap_filename);
  gtk_widget_show (web_pixmap);
  gtk_box_pack_start (GTK_BOX (web_address_box), web_pixmap, FALSE, FALSE, 0);

  web_list_box = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (web_list_box);
  gtk_box_pack_start (GTK_BOX (web_box), web_list_box, FALSE, FALSE, 0);

  web_buttonbox = gtk_vbutton_box_new ();
  gtk_widget_show (web_buttonbox);
  gtk_box_pack_start (GTK_BOX (web_list_box), web_buttonbox, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (web_buttonbox), 5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (web_buttonbox), GTK_BUTTONBOX_SPREAD);

  /*    web add 
   */
  web_add = gtk_button_new_with_label (_("Add"));
  gtk_widget_ref (web_add);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "web_add", web_add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (web_add);
  gtk_container_add (GTK_CONTAINER (web_buttonbox), web_add);
  GTK_WIDGET_SET_FLAGS (web_add, GTK_CAN_DEFAULT);

  /*    web modify
  */
  web_modify = gtk_button_new_with_label (_("Modify"));
  gtk_widget_ref (web_modify);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "web_modify", web_modify,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (web_modify);
  gtk_container_add (GTK_CONTAINER (web_buttonbox), web_modify);
  GTK_WIDGET_SET_FLAGS (web_modify, GTK_CAN_DEFAULT);

  /*    web delete
  */
  web_delete = gtk_button_new_with_label (_("Delete"));
  gtk_widget_ref (web_delete);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "web_delete", web_delete,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (web_delete);
  gtk_container_add (GTK_CONTAINER (web_buttonbox), web_delete);
  GTK_WIDGET_SET_FLAGS (web_delete, GTK_CAN_DEFAULT);

  web_scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (web_scrollwin);
  gtk_box_pack_start (GTK_BOX (web_list_box), web_scrollwin, TRUE, TRUE, 0);

  /*    desensibilizzo i bottoni modifica e cancella
  */
  gtk_widget_set_sensitive(GTK_WIDGET(web_modify), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(web_delete), FALSE);  

  /*    web clist
  */
  web_clist = gtk_clist_new (2);
  gtk_widget_ref (web_clist);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "web_clist", web_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (web_clist);
  gtk_container_add (GTK_CONTAINER (web_scrollwin), web_clist);
  gtk_clist_set_column_width (GTK_CLIST (web_clist), 0, 12);
  gtk_clist_set_column_width (GTK_CLIST (web_clist), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (web_clist));

  web_clist_pix_label = gtk_label_new ("");
  gtk_widget_show (web_clist_pix_label);
  gtk_clist_set_column_widget (GTK_CLIST (web_clist), 0, web_clist_pix_label);  

  web_clist_address_label = gtk_label_new (_("Web addresses"));
  gtk_widget_show (web_clist_address_label);
  gtk_clist_set_column_widget (GTK_CLIST (web_clist), 1, web_clist_address_label);

  email_frame = gtk_frame_new (_(" EMail "));
  gtk_widget_show (email_frame);
  gtk_box_pack_start (GTK_BOX (net_box), email_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (email_frame), 2);

  email_box = gtk_vbox_new (FALSE, 2);
  gtk_widget_show (email_box);
  gtk_container_add (GTK_CONTAINER (email_frame), email_box);

  email_address_box = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (email_address_box);
  gtk_box_pack_start (GTK_BOX (email_box), email_address_box, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (email_address_box), 2);

  email_label = gtk_label_new (_("Email address"));
  gtk_widget_show (email_label);
  gtk_box_pack_start (GTK_BOX (email_address_box), email_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (email_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (email_label), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (email_label), 5, 0);

  /*    email entry
  */
  email_entry = gtk_entry_new ();
  gtk_widget_ref (email_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "email_entry", email_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (email_entry);
  gtk_box_pack_start (GTK_BOX (email_address_box), email_entry, TRUE, TRUE, 0);

  email_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  email_pixmap_filename = gnome_pixmap_file ("rubrica/email.png");
  if (email_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (email_pixmap), email_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "email.png");
  g_free (email_pixmap_filename);
  gtk_widget_show (email_pixmap);
  gtk_box_pack_start (GTK_BOX (email_address_box), email_pixmap, FALSE, FALSE, 0);

  email_list_box = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (email_list_box);
  gtk_box_pack_start (GTK_BOX (email_box), email_list_box, FALSE, FALSE, 0);

  email_buttonbox = gtk_vbutton_box_new ();
  gtk_widget_show (email_buttonbox);
  gtk_box_pack_start (GTK_BOX (email_list_box), email_buttonbox, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (email_buttonbox), 5);

  /*    email add
  */
  email_add = gtk_button_new_with_label (_("Add"));
  gtk_widget_ref (email_add);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "email_add", email_add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (email_add);
  gtk_container_add (GTK_CONTAINER (email_buttonbox), email_add);
  GTK_WIDGET_SET_FLAGS (email_add, GTK_CAN_DEFAULT);

  /*    email modify
  */
  email_modify = gtk_button_new_with_label (_("Modify"));
  gtk_widget_ref (email_modify);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "email_modify", email_modify,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (email_buttonbox), email_modify);
  GTK_WIDGET_SET_FLAGS (email_modify, GTK_CAN_DEFAULT);
  gtk_widget_show (email_modify);

  /*    email delete
  */
  email_delete = gtk_button_new_with_label (_("Delete"));
  gtk_widget_ref (email_delete);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "email_delete", email_delete,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (email_buttonbox), email_delete);
  GTK_WIDGET_SET_FLAGS (email_delete, GTK_CAN_DEFAULT);
  gtk_widget_show (email_delete);

  email_scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (email_scrollwin);
  gtk_box_pack_start (GTK_BOX (email_list_box), email_scrollwin, TRUE, TRUE, 0);

  /*    desensibilizzo i bottoni modifica e cancella
  */
  gtk_widget_set_sensitive(GTK_WIDGET(email_modify), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(email_delete), FALSE);  

  /*    email clist
  */
  email_clist = gtk_clist_new (2);
  gtk_widget_ref (email_clist);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "email_clist", email_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (email_clist);
  gtk_container_add (GTK_CONTAINER (email_scrollwin), email_clist);
  gtk_clist_set_column_width (GTK_CLIST (email_clist), 0, 15);
  gtk_clist_set_column_width (GTK_CLIST (email_clist), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (email_clist));

  email_clist_pix_label = gtk_label_new ("");
  gtk_widget_show (email_clist_pix_label);
  gtk_clist_set_column_widget (GTK_CLIST (email_clist), 0, email_clist_pix_label);

  email_clist_address_label = gtk_label_new (_("Email addresses"));
  gtk_widget_show (email_clist_address_label);
  gtk_clist_set_column_widget (GTK_CLIST (email_clist), 1, email_clist_address_label);

 
  /*    
   *	FUNZIONI DI CALLBACK
   */

  /*    entry web, email
  */
  gtk_signal_connect (GTK_OBJECT (web_entry), "activate",
                      GTK_SIGNAL_FUNC (on_web_entry_activate),
                      web_add);
  gtk_signal_connect (GTK_OBJECT (email_entry), "activate",
                      GTK_SIGNAL_FUNC (on_email_entry_activate),
                      email_add);

  /*    bottoni web
  */
  gtk_signal_connect (GTK_OBJECT (web_add), "clicked",
                      GTK_SIGNAL_FUNC (on_bot_web_aggiungi_clicked),
                      MODULO_RUBRICA(modulo));
  gtk_signal_connect (GTK_OBJECT (web_modify), "clicked",
                      GTK_SIGNAL_FUNC (on_bot_web_modifica_clicked),
		      MODULO_RUBRICA(modulo));
  gtk_signal_connect (GTK_OBJECT (web_delete), "clicked",
                      GTK_SIGNAL_FUNC (on_bot_web_elimina_clicked),
                      MODULO_RUBRICA(modulo));

  /*    clist web
  */
  gtk_signal_connect (GTK_OBJECT (web_clist), "select_row",
                      GTK_SIGNAL_FUNC (on_web_clist_select_row),
		      MODULO_RUBRICA(modulo));
  /*
  gtk_signal_connect (GTK_OBJECT (web_clist), "unselect_row",
                      GTK_SIGNAL_FUNC (on_web_clist_unselect_row),
                      MODULO_RUBRICA(modulo));
  */

  /*    bottoni mail
  */
  gtk_signal_connect (GTK_OBJECT (email_add), "clicked",
                      GTK_SIGNAL_FUNC (on_bot_mail_aggiungi_clicked),
                      MODULO_RUBRICA(modulo));
  gtk_signal_connect (GTK_OBJECT (email_modify), "clicked",
                      GTK_SIGNAL_FUNC (on_bot_mail_modifica_clicked),
		      MODULO_RUBRICA(modulo));
  gtk_signal_connect (GTK_OBJECT (email_delete), "clicked",
                      GTK_SIGNAL_FUNC (on_bot_mail_elimina_clicked),
                      MODULO_RUBRICA(modulo));

  /*    clist mail
   */
  gtk_signal_connect (GTK_OBJECT (email_clist), "select_row",
                      GTK_SIGNAL_FUNC (on_mail_clist_select_row),
                      MODULO_RUBRICA(modulo));
  /*
  gtk_signal_connect (GTK_OBJECT (email_clist), "unselect_row",
                      GTK_SIGNAL_FUNC (on_mail_clist_unselect_row),
                      MODULO_RUBRICA(modulo));
  */

  return net_frame;
}

GtkWidget*
modulo_rubrica_crea_pagina_telefono(ModuloRubrica *modulo)
{
  GtkWidget *telephone_frame;

  GtkWidget *number_entry;

  GSList *type_table_group = NULL;
  GtkWidget *home_radio;
  GtkWidget *work_radio;
  GtkWidget *fax_radio;
  GtkWidget *cell_radio;
  GtkWidget *other_radio;

  GtkWidget *telephone_clist;

  GtkWidget *tel_add;
  GtkWidget *tel_modify;
  GtkWidget *tel_delete;

  GtkWidget *list_frame;
  GtkWidget *telephone_number_frame;
  GtkWidget *type_frame;
  GtkWidget *type_table;

  GtkWidget *telephone_box;
  GtkWidget *telephone_number_box;
  GtkWidget *telephone_list_box = NULL;
  GtkWidget *telephone_buttonbox;

  GtkWidget *number_label;
  GtkWidget *clist_pix_label;
  GtkWidget *clist_number_label;
  GtkWidget *clist_type_label;

  gchar *telephone_pixmap_filename;
  gchar *home_pixmap_filename;
  gchar *work_pixmap_filename;
  gchar *fax_pixmap_filename;
  gchar *cell_pixmap_filename;
  gchar *other_pixmap_filename;

  GtkWidget *telephone_pixmap;
  GtkWidget *work_pixmap;
  GtkWidget *fax_pixmap;
  GtkWidget *cell_pixmap;
  GtkWidget *home_pixmap;
  GtkWidget *other_pixmap;

  GtkWidget *list_scrollwin;

  telephone_frame = gtk_frame_new (_(" Telephone Info "));
  gtk_object_set_data_full (GTK_OBJECT (modulo), "telephone_frame", telephone_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (telephone_frame), 2);
  gtk_widget_show (telephone_frame);

  /*      main box
   */
  telephone_box = gtk_vbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (telephone_frame), telephone_box);
  gtk_container_set_border_width (GTK_CONTAINER (telephone_box), 2);
  gtk_widget_show (telephone_box);

  /*    number frame
  */
  telephone_number_frame = gtk_frame_new (_(" Telephone Number "));
  gtk_box_pack_start (GTK_BOX (telephone_box), telephone_number_frame, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (telephone_number_frame), 2);
  gtk_widget_show (telephone_number_frame);

  telephone_number_box = gtk_hbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (telephone_number_frame), telephone_number_box);
  gtk_container_set_border_width (GTK_CONTAINER (telephone_number_box), 2);
  gtk_widget_show (telephone_number_box);
  
  number_label = gtk_label_new (_("Number"));
  gtk_box_pack_start (GTK_BOX (telephone_number_box), number_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (number_label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (number_label), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (number_label), 10, 0);
  gtk_widget_show (number_label);

  /*    telephone list box
  */
  telephone_list_box = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (telephone_list_box);
  gtk_box_pack_start (GTK_BOX (telephone_box), telephone_list_box, TRUE, TRUE, 0);

  /*    Telephone Number Type 
	frame/table
  */
  type_frame = gtk_frame_new (_(" Telephone Type"));
  gtk_widget_show (type_frame);
  gtk_box_pack_start (GTK_BOX (telephone_list_box), type_frame, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (type_frame), 2);

  type_table = gtk_table_new (5, 2, FALSE);
  gtk_widget_show (type_table);
  gtk_container_add (GTK_CONTAINER (type_frame), type_table);
  gtk_container_set_border_width (GTK_CONTAINER (type_table), 5);

  /*    number entry
  */
  number_entry = gtk_entry_new ();
  gtk_widget_ref (number_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "number_entry", number_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (number_entry);
  gtk_box_pack_start (GTK_BOX (telephone_number_box), number_entry, TRUE, TRUE, 0);

  /*    telephone pixmap
  */
  telephone_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  telephone_pixmap_filename = gnome_pixmap_file ("rubrica/telefono.png");
  if (telephone_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (telephone_pixmap), 
			    telephone_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "telefono.png");
  g_free (telephone_pixmap_filename);
  gtk_widget_show (telephone_pixmap);
  gtk_box_pack_start (GTK_BOX (telephone_number_box), telephone_pixmap, 
		      FALSE, FALSE, 0);

  /*    home pixmap
   */  
  home_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  home_pixmap_filename = gnome_pixmap_file ("rubrica/casa.png");
  if (home_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (home_pixmap), home_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "casa.png");
  g_free (home_pixmap_filename);
  gtk_widget_show (home_pixmap);
  gtk_table_attach (GTK_TABLE (type_table), home_pixmap, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND), 0, 0);

  /*    work pixmap
  */
  work_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  work_pixmap_filename = gnome_pixmap_file ("rubrica/work.png");
  if (work_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (work_pixmap), work_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "work.png");
  g_free (work_pixmap_filename);
  gtk_widget_show (work_pixmap);
  gtk_table_attach (GTK_TABLE (type_table), work_pixmap, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND), 0, 0);

  /*    fax pixmap
   */  
  fax_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  fax_pixmap_filename = gnome_pixmap_file ("rubrica/fax.png");
  if (fax_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (fax_pixmap), fax_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "fax.png");
  g_free (fax_pixmap_filename);
  gtk_widget_show (fax_pixmap);
  gtk_table_attach (GTK_TABLE (type_table), fax_pixmap, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND), 0, 0);

  /*    cellphone pixmap
   */  
  cell_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  cell_pixmap_filename = gnome_pixmap_file ("rubrica/cellulare.png");
  if (cell_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (cell_pixmap), cell_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "cellulare.png");
  g_free (cell_pixmap_filename);
  gtk_widget_show (cell_pixmap);
  gtk_table_attach (GTK_TABLE (type_table), cell_pixmap, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND), 0, 0);

  /*    other pixmap
   */  
  other_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  other_pixmap_filename = gnome_pixmap_file ("rubrica/altrotel.png");
  if (other_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (other_pixmap), other_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "altrotel.png");
  g_free (other_pixmap_filename);
  gtk_widget_show (other_pixmap);
  gtk_table_attach (GTK_TABLE (type_table), other_pixmap, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  /*    radio home
  */
  home_radio = gtk_radio_button_new_with_label (type_table_group, _("Home telephone"));
  type_table_group = gtk_radio_button_group (GTK_RADIO_BUTTON (home_radio));
  gtk_widget_ref (home_radio);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "home_radio", home_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (home_radio);
  gtk_table_attach (GTK_TABLE (type_table), home_radio, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    radio work
  */
  work_radio = gtk_radio_button_new_with_label (type_table_group, _("Work telephone"));
  type_table_group = gtk_radio_button_group (GTK_RADIO_BUTTON (work_radio));
  gtk_widget_ref (work_radio);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "work_radio", work_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (work_radio);
  gtk_table_attach (GTK_TABLE (type_table), work_radio, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    radio fax
  */
  fax_radio = gtk_radio_button_new_with_label (type_table_group, _("Fax telephone"));
  type_table_group = gtk_radio_button_group (GTK_RADIO_BUTTON (fax_radio));
  gtk_widget_ref (fax_radio);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "fax_radio", fax_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fax_radio);
  gtk_table_attach (GTK_TABLE (type_table), fax_radio, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    radio cellphone
  */
  cell_radio = gtk_radio_button_new_with_label (type_table_group, _("Cellphone"));
  type_table_group = gtk_radio_button_group (GTK_RADIO_BUTTON (cell_radio));
  gtk_widget_ref (cell_radio);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "cell_radio", cell_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cell_radio);
  gtk_table_attach (GTK_TABLE (type_table), cell_radio, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    other radio
  */
  other_radio = gtk_radio_button_new_with_label (type_table_group, 
						 _("Other telephone"));
  type_table_group = gtk_radio_button_group (GTK_RADIO_BUTTON (other_radio));
  gtk_widget_ref (other_radio);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "other_radio", other_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (other_radio);
  gtk_table_attach (GTK_TABLE (type_table), other_radio, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    imposto il bottone attivo di default 
  */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (home_radio), TRUE);

  list_frame = gtk_frame_new (_(" Telephone List "));
  gtk_widget_show (list_frame);
  gtk_box_pack_start (GTK_BOX (telephone_list_box), list_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (list_frame), 2);

  list_scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (list_scrollwin);
  gtk_container_add (GTK_CONTAINER (list_frame), list_scrollwin);

  /*    telephone clist
  */
  telephone_clist = gtk_clist_new (3);
  gtk_widget_ref (telephone_clist);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "telephone_clist", 
			    telephone_clist, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (telephone_clist);
  gtk_container_add (GTK_CONTAINER (list_scrollwin), telephone_clist);
  gtk_container_set_border_width (GTK_CONTAINER (telephone_clist), 2);
  gtk_clist_set_column_width (GTK_CLIST (telephone_clist), 0, 15);
  gtk_clist_set_column_width (GTK_CLIST (telephone_clist), 1, 165);
  gtk_clist_set_column_width (GTK_CLIST (telephone_clist), 2, 80);
  gtk_clist_column_titles_show (GTK_CLIST (telephone_clist));

  clist_pix_label = gtk_label_new ("");
  gtk_widget_show (clist_pix_label);
  gtk_clist_set_column_widget (GTK_CLIST (telephone_clist), 0, clist_pix_label);

  clist_number_label = gtk_label_new (_("Number"));
  gtk_widget_show (clist_number_label);
  gtk_clist_set_column_widget (GTK_CLIST (telephone_clist), 1, clist_number_label);

  clist_type_label = gtk_label_new (_("Type"));
  gtk_widget_show (clist_type_label);
  gtk_clist_set_column_widget (GTK_CLIST (telephone_clist), 2, clist_type_label);

  telephone_buttonbox = gtk_hbutton_box_new ();
  gtk_widget_show (telephone_buttonbox);
  gtk_box_pack_start (GTK_BOX (telephone_box), telephone_buttonbox, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (telephone_buttonbox), 2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (telephone_buttonbox), 
			     GTK_BUTTONBOX_SPREAD);

  /*    telephone add
  */
  tel_add = gtk_button_new_with_label (_("Add"));
  gtk_widget_ref (tel_add);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "tel_add", tel_add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tel_add);
  gtk_container_add (GTK_CONTAINER (telephone_buttonbox), tel_add);
  GTK_WIDGET_SET_FLAGS (tel_add, GTK_CAN_DEFAULT);

  /*    telephone modify
  */
  tel_modify = gtk_button_new_with_label (_("Modify"));
  gtk_widget_ref (tel_modify);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "tel_modify", tel_modify,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tel_modify);
  gtk_container_add (GTK_CONTAINER (telephone_buttonbox), tel_modify);
  GTK_WIDGET_SET_FLAGS (tel_modify, GTK_CAN_DEFAULT);

  /*    telephone delete
  */
  tel_delete = gtk_button_new_with_label (_("Delete"));
  gtk_widget_ref (tel_delete);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "tel_delete", tel_delete,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tel_delete);
  gtk_container_add (GTK_CONTAINER (telephone_buttonbox), tel_delete);
  GTK_WIDGET_SET_FLAGS (tel_delete, GTK_CAN_DEFAULT);

  /*    desensibilizzo i bottoni modifica e cancella
  */                                  
  gtk_widget_set_sensitive(GTK_WIDGET(tel_modify), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(tel_delete), FALSE);  

  /*
   * COLLEGAMENTO A FUNZIONI CALLBACK
   */ 
  gtk_signal_connect (GTK_OBJECT (number_entry), "activate",
                      GTK_SIGNAL_FUNC (on_tel_entry_activate),
                      tel_add);

  gtk_signal_connect (GTK_OBJECT (cell_radio), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_cellulare_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (fax_radio), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_fax_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (work_radio), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_ufficio_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (home_radio), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_casa_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (other_radio), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_altro_toggled),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (telephone_clist), "select_row",
                      GTK_SIGNAL_FUNC (on_telefono_clist_select_row),
                      MODULO_RUBRICA(modulo));

  gtk_signal_connect (GTK_OBJECT (tel_add), "clicked",
                      GTK_SIGNAL_FUNC (on_bot_tel_aggiungi_clicked),
                      MODULO_RUBRICA(modulo));
  gtk_signal_connect (GTK_OBJECT (tel_modify), "clicked",
                      GTK_SIGNAL_FUNC (on_bot_tel_modifica_clicked),
		      MODULO_RUBRICA(modulo));
  gtk_signal_connect (GTK_OBJECT (tel_delete), "clicked",
                      GTK_SIGNAL_FUNC (on_bot_tel_elimina_clicked),
                      MODULO_RUBRICA(modulo));

  return telephone_frame;
}

GtkWidget*
modulo_rubrica_crea_pagina_work (ModuloRubrica *modulo)
{
  GtkWidget *work_frame;

  GtkWidget *company_frame;
  GtkWidget *assigment_frame;

  GtkWidget *street_entry;
  GtkWidget *street_number_entry;
  GtkWidget *company_entry;
  GtkWidget *zip_code_entry;
  GtkWidget *city_entry;
  GtkWidget *province_entry;
  GtkWidget *country_entry;
  GtkWidget *web_entry;
  GtkWidget *operator_entry;
  GtkWidget *email_entry;
  GtkWidget *fax_entry;
  GtkWidget *green_entry;
  GtkWidget *customer_entry;
  GtkWidget *department_entry;
  GtkWidget *sub_dep_entry;
  GtkWidget *secretary_entry;
  GtkWidget *assigment_entry;
  GtkWidget *org_entry;
  GtkWidget *phone_entry;

  GtkWidget *note_text;

  GtkWidget *work_box;
  GtkWidget *info_box;
  GtkWidget *info_pixmap_hbox;
  GtkWidget *assigment_box;
  GtkWidget *assigment_pixmap_box;

  GtkWidget *company_table;
  GtkWidget *assigment_table;

  GtkWidget *company_label;
  GtkWidget *street_label;
  GtkWidget *street_number_label;
  GtkWidget *zip_code_label;
  GtkWidget *city_label;
  GtkWidget *province_label;
  GtkWidget *country_label;
  GtkWidget *web_label;
  GtkWidget *email_label;
  GtkWidget *operator_label;
  GtkWidget *fax_label;
  GtkWidget *note_label;
  GtkWidget *green_label;
  GtkWidget *customer_label;
  GtkWidget *assigment_label;
  GtkWidget *org_label;
  GtkWidget *secretary_label;
  GtkWidget *phone_label;
  GtkWidget *department_label;
  GtkWidget *sub_dep_label;

  gchar *company_pixmap_filename;
  gchar *assigment_pixmap_filename;
  GtkWidget *company_pixmap;
  GtkWidget *assigment_pixmap;

  GtkWidget *note_scrollwin;

  work_frame = gtk_frame_new (_(" Work "));
  gtk_object_set_data_full (GTK_OBJECT (modulo), "work_frame", work_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (work_frame);
  gtk_container_set_border_width (GTK_CONTAINER (work_frame), 1);

  work_box = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (work_box);
  gtk_container_add (GTK_CONTAINER (work_frame), work_box);

  company_frame = gtk_frame_new (_(" Company infos "));
  gtk_widget_show (company_frame);
  gtk_box_pack_start (GTK_BOX (work_box), company_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (company_frame), 1);

  info_box = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (info_box);
  gtk_container_add (GTK_CONTAINER (company_frame), info_box);

  info_pixmap_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (info_pixmap_hbox);
  gtk_box_pack_start (GTK_BOX (info_box), info_pixmap_hbox, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (info_pixmap_hbox), 2);

  company_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  company_pixmap_filename = gnome_pixmap_file ("rubrica/puzzle.png");
  if (company_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (company_pixmap), company_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "puzzle.png");
  g_free (company_pixmap_filename);
  gtk_widget_show (company_pixmap);
  gtk_box_pack_start (GTK_BOX (info_pixmap_hbox), company_pixmap, FALSE, FALSE, 0);

  company_table = gtk_table_new (8, 4, FALSE);
  gtk_widget_show (company_table);
  gtk_box_pack_start (GTK_BOX (info_box), company_table, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (company_table), 2);
  gtk_table_set_row_spacings (GTK_TABLE (company_table), 2);
  gtk_table_set_col_spacings (GTK_TABLE (company_table), 2);

  company_label = gtk_label_new (_("Company name"));
  gtk_widget_show (company_label);
  gtk_table_attach (GTK_TABLE (company_table), company_label, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (company_label), 0, 0.5);

  street_label = gtk_label_new (_("Street "));
  gtk_widget_show (street_label);
  gtk_table_attach (GTK_TABLE (company_table), street_label, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (street_label), 0, 0.5);

  street_number_label = gtk_label_new (_("Street  Number"));
  gtk_widget_show (street_number_label);
  gtk_table_attach (GTK_TABLE (company_table), street_number_label, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (street_number_label), 0, 0.5);

  /*    street entry
  */
  street_entry = gtk_entry_new ();
  gtk_widget_ref (street_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_street_entry", street_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (street_entry);
  gtk_table_attach (GTK_TABLE (company_table), street_entry, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    street number entry
  */  
  street_number_entry = gtk_entry_new ();
  gtk_widget_ref (street_number_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_street_number_entry", 
			    street_number_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (street_number_entry);
  gtk_table_attach (GTK_TABLE (company_table), street_number_entry, 3, 4, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  /*    company entry
  */
  company_entry = gtk_entry_new ();
  gtk_widget_ref (company_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_entry", company_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (company_entry);
  gtk_table_attach (GTK_TABLE (company_table), company_entry, 1, 4, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  zip_code_label = gtk_label_new (_("Zip Code"));
  gtk_widget_show (zip_code_label);
  gtk_table_attach (GTK_TABLE (company_table), zip_code_label, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (zip_code_label), 0, 0.5);

  /*    zip code entry
  */
  zip_code_entry = gtk_entry_new ();
  gtk_widget_ref (zip_code_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_zip_code_entry", 
			    zip_code_entry,  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (zip_code_entry);
  gtk_table_attach (GTK_TABLE (company_table), zip_code_entry, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  city_label = gtk_label_new (_("City"));
  gtk_widget_show (city_label);
  gtk_table_attach (GTK_TABLE (company_table), city_label, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (city_label), 0, 0.5);

  /*    city entry
  */
  city_entry = gtk_entry_new ();
  gtk_widget_ref (city_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_city_entry", city_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (city_entry);
  gtk_table_attach (GTK_TABLE (company_table), city_entry, 3, 4, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  province_label = gtk_label_new (_("Province"));
  gtk_widget_show (province_label);
  gtk_table_attach (GTK_TABLE (company_table), province_label, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (province_label), 0, 0.5);

  country_label = gtk_label_new (_("Country"));
  gtk_widget_show (country_label);
  gtk_table_attach (GTK_TABLE (company_table), country_label, 2, 3, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (country_label), 0, 0.5);

  /*    province entry
  */
  province_entry = gtk_entry_new ();
  gtk_widget_ref (province_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_province_entry", 
			    province_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (province_entry);
  gtk_table_attach (GTK_TABLE (company_table), province_entry, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    country entry
  */
  country_entry = gtk_entry_new ();
  gtk_widget_ref (country_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_country_entry", 
			    country_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (country_entry);
  gtk_table_attach (GTK_TABLE (company_table), country_entry, 3, 4, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  web_label = gtk_label_new (_("Web Page"));
  gtk_widget_show (web_label);
  gtk_table_attach (GTK_TABLE (company_table), web_label, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (web_label), 0, 0.5);

  email_label = gtk_label_new (_("Email"));
  gtk_widget_show (email_label);
  gtk_table_attach (GTK_TABLE (company_table), email_label, 2, 3, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (email_label), 0, 0.5);

  operator_label = gtk_label_new (_("Operator"));
  gtk_widget_show (operator_label);
  gtk_table_attach (GTK_TABLE (company_table), operator_label, 0, 1, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (operator_label), 0, 0.5);

  fax_label = gtk_label_new (_("Fax"));
  gtk_widget_show (fax_label);
  gtk_table_attach (GTK_TABLE (company_table), fax_label, 2, 3, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (fax_label), 0, 0.5);

  /*    web entry
  */
  web_entry = gtk_entry_new ();
  gtk_widget_ref (web_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_web_entry", web_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (web_entry);
  gtk_table_attach (GTK_TABLE (company_table), web_entry, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    operator entry
   */
  operator_entry = gtk_entry_new ();
  gtk_widget_ref (operator_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_operator_entry", 
			    operator_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (operator_entry);
  gtk_table_attach (GTK_TABLE (company_table), operator_entry, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    email entry
  */
  email_entry = gtk_entry_new ();
  gtk_widget_ref (email_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_email_entry", email_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (email_entry);
  gtk_table_attach (GTK_TABLE (company_table), email_entry, 3, 4, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    fax entry
  */
  fax_entry = gtk_entry_new ();
  gtk_widget_ref (fax_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_fax_entry", fax_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fax_entry);
  gtk_table_attach (GTK_TABLE (company_table), fax_entry, 3, 4, 5, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  note_label = gtk_label_new (_("Notes"));
  gtk_widget_show (note_label);
  gtk_table_attach (GTK_TABLE (company_table), note_label, 0, 1, 7, 8,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (note_label), 0, 0);

  note_scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (note_scrollwin);
  gtk_table_attach (GTK_TABLE (company_table), note_scrollwin, 1, 4, 7, 8,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (note_scrollwin), 
				  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  /*    note text
  */
  note_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (note_text);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_note_text", note_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (note_text);
  gtk_container_add (GTK_CONTAINER (note_scrollwin), note_text);
  gtk_text_set_editable (GTK_TEXT (note_text), TRUE);

  green_label = gtk_label_new (_("Green"));
  gtk_widget_show (green_label);
  gtk_table_attach (GTK_TABLE (company_table), green_label, 0, 1, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (green_label), 0, 0.5);

  /*    green entry
  */
  green_entry = gtk_entry_new ();
  gtk_widget_ref (green_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_green_entry", green_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (green_entry);
  gtk_table_attach (GTK_TABLE (company_table), green_entry, 1, 2, 6, 7,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  customer_label = gtk_label_new (_("Customer Care"));
  gtk_widget_show (customer_label);
  gtk_table_attach (GTK_TABLE (company_table), customer_label, 2, 3, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (customer_label), 0, 0.5);

  /*    customer entry
  */
  customer_entry = gtk_entry_new ();
  gtk_widget_ref (customer_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "company_customer_entry", 
			    customer_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (customer_entry);
  gtk_table_attach (GTK_TABLE (company_table), customer_entry, 3, 4, 6, 7,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  assigment_frame = gtk_frame_new (_(" Assigment "));
  gtk_widget_show (assigment_frame);
  gtk_box_pack_start (GTK_BOX (work_box), assigment_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (assigment_frame), 1);

  assigment_box = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (assigment_box);
  gtk_container_add (GTK_CONTAINER (assigment_frame), assigment_box);

  assigment_pixmap_box = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (assigment_pixmap_box);
  gtk_box_pack_start (GTK_BOX (assigment_box), assigment_pixmap_box, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (assigment_pixmap_box), 2);

  assigment_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  assigment_pixmap_filename = gnome_pixmap_file ("rubrica/role.png");
  if (assigment_pixmap_filename)
    gnome_pixmap_load_file(GNOME_PIXMAP(assigment_pixmap), assigment_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "role.png");
  g_free (assigment_pixmap_filename);
  gtk_widget_show (assigment_pixmap);
  gtk_box_pack_start (GTK_BOX (assigment_pixmap_box), assigment_pixmap,
		      FALSE, FALSE, 0);

  assigment_table = gtk_table_new (4, 4, FALSE);
  gtk_widget_show (assigment_table);
  gtk_box_pack_start (GTK_BOX (assigment_box), assigment_table, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (assigment_table), 2);
  gtk_table_set_row_spacings (GTK_TABLE (assigment_table), 2);
  gtk_table_set_col_spacings (GTK_TABLE (assigment_table), 2);

  assigment_label = gtk_label_new (_("Assigment"));
  gtk_widget_show (assigment_label);
  gtk_table_attach (GTK_TABLE (assigment_table), assigment_label, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (assigment_label), 0, 0.5);

  /*    department entry
  */
  department_entry = gtk_entry_new ();
  gtk_widget_ref (department_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "department_entry", department_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (department_entry);
  gtk_table_attach (GTK_TABLE (assigment_table), department_entry, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    sub department entry
  */
  sub_dep_entry = gtk_entry_new ();
  gtk_widget_ref (sub_dep_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "sub_dep_entry", sub_dep_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sub_dep_entry);
  gtk_table_attach (GTK_TABLE (assigment_table), sub_dep_entry, 3, 4, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    secretary entry
  */
  secretary_entry = gtk_entry_new ();
  gtk_widget_ref (secretary_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "secretary_entry", secretary_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (secretary_entry);
  gtk_table_attach (GTK_TABLE (assigment_table), secretary_entry, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    assigment entry
  */
  assigment_entry = gtk_entry_new ();
  gtk_widget_ref (assigment_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "assigment_entry", assigment_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (assigment_entry);
  gtk_table_attach (GTK_TABLE (assigment_table), assigment_entry, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  org_label = gtk_label_new (_("Organization"));
  gtk_widget_show (org_label);
  gtk_table_attach (GTK_TABLE (assigment_table), org_label, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (org_label), 0, 0.5);

  /*    organization entry
  */
  org_entry = gtk_entry_new ();
  gtk_widget_ref (org_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "org_entry", org_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (org_entry);
  gtk_table_attach (GTK_TABLE (assigment_table), org_entry, 3, 4, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  secretary_label = gtk_label_new (_("Secretary name"));
  gtk_widget_show (secretary_label);
  gtk_table_attach (GTK_TABLE (assigment_table), secretary_label, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (secretary_label), 0, 0.5);

  phone_label = gtk_label_new (_("Secretary phone"));
  gtk_widget_show (phone_label);
  gtk_table_attach (GTK_TABLE (assigment_table), phone_label, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (phone_label), 0, 0.5);

  /*    secretary phone 
  */
  phone_entry = gtk_entry_new ();
  gtk_widget_ref (phone_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "phone_entry", phone_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (phone_entry);
  gtk_table_attach (GTK_TABLE (assigment_table), phone_entry, 3, 4, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  department_label = gtk_label_new (_("Department"));
  gtk_widget_show (department_label);
  gtk_table_attach (GTK_TABLE (assigment_table), department_label, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (department_label), 0, 0.5);

  sub_dep_label = gtk_label_new (_("Sub-department"));
  gtk_widget_show (sub_dep_label);
  gtk_table_attach (GTK_TABLE (assigment_table), sub_dep_label, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (sub_dep_label), 0, 0.5);

  return work_frame;
}

GtkWidget*
modulo_rubrica_crea_pagina_note(ModuloRubrica *modulo)
{
  GtkWidget *note_frame;

  GtkWidget *spouse_entry;

  GtkWidget *married_check;
  GtkWidget *children_check;

  GtkWidget *birthday_date;
  GtkWidget *anniversary_date;

  GtkWidget *children_text;
  GtkWidget *hobbies_text;
  GtkWidget *notes_text;
  GtkWidget *pub_key_text;

  GtkWidget *personale_frame;
  GtkWidget *pub_key_frame;

  GtkWidget *personal_table;

  GtkWidget *note_box;
  GtkWidget *personal_box;
  GtkWidget *personal_pixmap_box;
  GtkWidget *pub_key_main_box;
  GtkWidget *pub_key_box;
  GtkWidget *pub_key_pixmap_box;
  GtkWidget *hobbies_pixmap_main_box;
  GtkWidget *hobbies_pixmap_box;

  GtkWidget *spouse_label;
  GtkWidget *birthday_label;
  GtkWidget *anniversary_label;
  GtkWidget *hobbies_label;
  GtkWidget *notes_label;
  GtkWidget *pub_key_label;

  GtkWidget *children_scrollwin;
  GtkWidget *notes_scrollwin;
  GtkWidget *hobbies_scrollwin;
  GtkWidget *pub_key_scrollwin;

  gchar *personal_pixmap_filename;
  gchar *pub_key_pixmap_filename;
  gchar *hobby_pixmap_filename;

  GtkWidget *personal_pixmap;
  GtkWidget *pub_key_pixmap;
  GtkWidget *hobby_pixmap;

  note_frame = gtk_frame_new (_(" Misc "));
  gtk_object_set_data_full (GTK_OBJECT (modulo), "note_frame", note_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (note_frame);
  gtk_container_set_border_width (GTK_CONTAINER (note_frame), 2);

  note_box = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (note_box);
  gtk_container_add (GTK_CONTAINER (note_frame), note_box);

  personale_frame = gtk_frame_new (_(" Personal Notes "));
  gtk_widget_show (personale_frame);
  gtk_box_pack_start (GTK_BOX (note_box), personale_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (personale_frame), 1);

  personal_box = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (personal_box);
  gtk_container_add (GTK_CONTAINER (personale_frame), personal_box);

  personal_pixmap_box = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (personal_pixmap_box);
  gtk_box_pack_start (GTK_BOX (personal_box), personal_pixmap_box, FALSE, FALSE, 0);

  personal_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  personal_pixmap_filename = gnome_pixmap_file ("rubrica/post-it.png");
  if (personal_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (personal_pixmap), personal_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "post-it.png");
  g_free (personal_pixmap_filename);
  gtk_widget_show (personal_pixmap);
  gtk_box_pack_start (GTK_BOX (personal_pixmap_box), personal_pixmap, FALSE, FALSE, 0);

  personal_table = gtk_table_new (6, 4, FALSE);
  gtk_widget_show (personal_table);
  gtk_box_pack_start (GTK_BOX (personal_box), personal_table, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (personal_table), 2);
  gtk_table_set_row_spacings (GTK_TABLE (personal_table), 1);
  gtk_table_set_col_spacings (GTK_TABLE (personal_table), 1);

  /*    married check button
  */
  married_check = gtk_check_button_new_with_label (_("Married"));
  gtk_widget_ref (married_check);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "married_check", married_check,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (married_check);
  gtk_table_attach (GTK_TABLE (personal_table), married_check, 0, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  
  spouse_label = gtk_label_new (_("Spouse's name"));
  gtk_widget_show (spouse_label);
  gtk_table_attach (GTK_TABLE (personal_table), spouse_label, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (spouse_label), 0, 0.5);

  /*    spouse entry
  */
  spouse_entry = gtk_entry_new ();
  gtk_widget_ref (spouse_entry);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "spouse_entry", spouse_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spouse_entry);
  gtk_table_attach (GTK_TABLE (personal_table), spouse_entry, 3, 4, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  birthday_label = gtk_label_new (_("Spouse's birthday:"));
  gtk_widget_show (birthday_label);
  gtk_table_attach (GTK_TABLE (personal_table), birthday_label, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (birthday_label), 0, 0.5);

  /*    spouse birthday date
  */
  birthday_date = gnome_date_edit_new ((time_t) 0, FALSE, FALSE);
  gtk_widget_ref (birthday_date);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "spouse_birthday", birthday_date,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (birthday_date);
  gtk_table_attach (GTK_TABLE (personal_table), birthday_date, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    anniversary
  */
  anniversary_label = gtk_label_new (_("Anniversary:"));
  gtk_widget_show (anniversary_label);
  gtk_table_attach (GTK_TABLE (personal_table), anniversary_label, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (anniversary_label), 0, 0.5);

  /*    anniversary date
  */
  anniversary_date = gnome_date_edit_new ((time_t) 0, FALSE, FALSE);
  gtk_widget_ref (anniversary_date);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "anniversary", 
			    anniversary_date, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (anniversary_date);
  gtk_table_attach (GTK_TABLE (personal_table), anniversary_date, 3, 4, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    buttons sensitivities
  */
  gtk_widget_set_sensitive(spouse_entry,
			   gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
							(married_check)));
  gtk_widget_set_sensitive(birthday_date,
			   gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
							(married_check)));
  gtk_widget_set_sensitive(anniversary_date,
			   gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
							(married_check)));

  /*    children check button
  */
  children_check = gtk_check_button_new_with_label (_("Children"));
  gtk_widget_ref (children_check);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "children_check", children_check,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (children_check);
  gtk_table_attach (GTK_TABLE (personal_table), children_check, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  /*    children text
  */
  children_scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (children_scrollwin);
  gtk_table_attach (GTK_TABLE (personal_table), children_scrollwin, 1, 4, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (children_scrollwin), 
				  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  children_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (children_text);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "children_text", children_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (children_text);
  gtk_container_add (GTK_CONTAINER (children_scrollwin), children_text);
  gtk_text_set_editable (GTK_TEXT (children_text), TRUE);

  gtk_widget_set_sensitive(children_text, 
			   gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
							(children_check)));

  /*    hobbies
   */
  hobbies_pixmap_main_box = gtk_hbox_new (FALSE, 0);
  gtk_table_attach (GTK_TABLE (personal_table), hobbies_pixmap_main_box, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_show (hobbies_pixmap_main_box);

  hobbies_pixmap_box = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hobbies_pixmap_main_box), hobbies_pixmap_box, 
		      FALSE, FALSE, 0);
  gtk_widget_show (hobbies_pixmap_box);

  hobbies_label = gtk_label_new (_("Hobbies:"));
  gtk_box_pack_start (GTK_BOX (hobbies_pixmap_box), hobbies_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (hobbies_label), GTK_JUSTIFY_FILL);
  gtk_label_set_line_wrap (GTK_LABEL (hobbies_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (hobbies_label), 0, 0);
  gtk_widget_show (hobbies_label);

  hobby_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  hobby_pixmap_filename = gnome_pixmap_file ("rubrica/multimedia.png");
  if (hobby_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (hobby_pixmap), hobby_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "multimedia.png");
  g_free (hobby_pixmap_filename);
  gtk_widget_show (hobby_pixmap);
  gtk_box_pack_start (GTK_BOX (hobbies_pixmap_box), hobby_pixmap, FALSE, FALSE, 0);

  hobbies_scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (hobbies_scrollwin);
  gtk_table_attach (GTK_TABLE (personal_table), hobbies_scrollwin, 1, 4, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (hobbies_scrollwin), 
				  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  /*    hobbies text
  */
  hobbies_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (hobbies_text);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "hobbies_text", hobbies_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hobbies_text);
  gtk_container_add (GTK_CONTAINER (hobbies_scrollwin), hobbies_text);
  gtk_text_set_editable (GTK_TEXT (hobbies_text), TRUE);



  /*    notes
  */
  notes_label = gtk_label_new (_("Other notes:"));
  gtk_widget_show (notes_label);
  gtk_table_attach (GTK_TABLE (personal_table), notes_label, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (notes_label), GTK_JUSTIFY_FILL);
  gtk_label_set_line_wrap (GTK_LABEL (notes_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (notes_label), 0, 0);

  notes_scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (notes_scrollwin);
  gtk_table_attach (GTK_TABLE (personal_table), notes_scrollwin, 1, 4, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (notes_scrollwin), 
				  GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);


  /*    notes text
  */
  notes_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (notes_text);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "notes_text", notes_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notes_text);
  gtk_container_add (GTK_CONTAINER (notes_scrollwin), notes_text);
  gtk_text_set_editable (GTK_TEXT (notes_text), TRUE);



  /*    public key
   */
  pub_key_frame = gtk_frame_new (_(" Public Key "));
  gtk_widget_show (pub_key_frame);
  gtk_box_pack_start (GTK_BOX (note_box), pub_key_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (pub_key_frame), 2);

  pub_key_main_box = gtk_vbox_new (FALSE, 3);
  gtk_widget_show (pub_key_main_box);
  gtk_container_add (GTK_CONTAINER (pub_key_frame), pub_key_main_box);
  gtk_container_set_border_width (GTK_CONTAINER (pub_key_main_box), 2);

  pub_key_box = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (pub_key_box);
  gtk_box_pack_start (GTK_BOX (pub_key_main_box), pub_key_box, TRUE, TRUE, 0);

  pub_key_pixmap_box = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (pub_key_pixmap_box);
  gtk_box_pack_start (GTK_BOX (pub_key_box), pub_key_pixmap_box, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (pub_key_pixmap_box), 2);
  
  /*    public key pixmap 
   */
  pub_key_pixmap = gtk_type_new (gnome_pixmap_get_type ());
  pub_key_pixmap_filename = gnome_pixmap_file ("rubrica/keys.png");
  if (pub_key_pixmap_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (pub_key_pixmap), pub_key_pixmap_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "keys.png");
  g_free (pub_key_pixmap_filename);
  gtk_widget_show (pub_key_pixmap);
  gtk_box_pack_start (GTK_BOX (pub_key_pixmap_box), pub_key_pixmap, FALSE, FALSE, 0);

  pub_key_label = gtk_label_new (_("Key: "));
  gtk_widget_show (pub_key_label);
  gtk_box_pack_start (GTK_BOX (pub_key_pixmap_box), pub_key_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (pub_key_label), GTK_JUSTIFY_FILL);
  gtk_label_set_line_wrap (GTK_LABEL (pub_key_label), TRUE);
  gtk_misc_set_alignment (GTK_MISC (pub_key_label), 0, 0.5);

  pub_key_scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (pub_key_scrollwin);
  gtk_box_pack_start (GTK_BOX (pub_key_box), pub_key_scrollwin, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (pub_key_scrollwin), 4);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (pub_key_scrollwin), 
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  /*    public key text
  */
  pub_key_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (pub_key_text);
  gtk_object_set_data_full (GTK_OBJECT (modulo), "pub_key_text", pub_key_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pub_key_text);
  gtk_container_add (GTK_CONTAINER (pub_key_scrollwin), pub_key_text);
  gtk_text_set_editable (GTK_TEXT (pub_key_text), TRUE);

  gtk_signal_connect (GTK_OBJECT (married_check), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_married_toggled),
                      MODULO_RUBRICA(modulo));
  gtk_signal_connect (GTK_OBJECT (children_check), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_children_toggled),
                      MODULO_RUBRICA(modulo));

  return note_frame;
}

