/*
*  Rubrica
*  file: search.h
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "rubrica.h"

#ifndef __RUBRICA_SEARCH__
#define __RUBRICA_SEARCH__

typedef enum {
  CARD = 0,
  NAME,
  SURNAME,
  STATE,
  CITY,
  PROF,
  WEB,
  MAIL,
  TEL
} WhereSearch;

typedef enum {
  CASE_SENSITIVE = 0,     /* search is case sensitive    */
  CASE_INSENSITIVE,       /* search isn't case sensitive */
  FULL_MATCH,             /* string_searched == stored_string          */
  PARTIAL_MATCH,          /* string_searched == partial_strored_string */
  END_HOW
} HowSearch;

void rubrica_search_init(void);
void rubrica_search_free_coda(GList *c);

void rubrica_search_where_set(WhereSearch where);
void rubrica_search_sensitive_set(HowSearch how);
void rubrica_search_into_set(HowSearch hs);

void rubrica_search_item(void);
gboolean rubrica_search_match(gchar *str);
gboolean rubrica_search_submatch(gchar *str, gboolean how);

void rubrica_search_insert_item_found(gchar *card, gchar *str, gint pos);
void rubrica_search_view_item(gint i);

#endif
