/*
*  Rubrica
*  file: view.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <gnome.h>

#include "rubrica.h"
#include "main.h"


static gint totale_indirizzi = 0;
static GtkWidget *clist_dati = NULL;
static GtkWidget *progressbar = NULL;

void rubrica_view_init(GtkWidget *dati, GtkWidget *pbar)
{
  clist_dati  = dati;               
  progressbar = pbar;               
}

GtkCList *rubrica_view_get_dati(void)
{
  return GTK_CLIST(clist_dati);
}

GtkWidget *rubrica_view_get_progressbar(void)
{
  return progressbar;
}

void rubrica_view_update_path(gchar *str)
{
  GtkWidget *window;
  GtkWidget *label;
  
  window = rubrica_get_app();
  label = gtk_object_get_data(GTK_OBJECT(window), "label_path");

  gtk_label_set_text(GTK_LABEL(label),str);		   
}


/*  gestione indirizzi
*/

inline gint rubrica_view_get_indirizzi(void)  
{
  return (gint) totale_indirizzi;  
}

inline void rubrica_view_set_indirizzi(gint n)  
{
  totale_indirizzi = n;  

  gtk_progress_set_value(GTK_PROGRESS(progressbar), (float) totale_indirizzi);  
}

inline void rubrica_view_inc_indirizzi(void)  
{
  totale_indirizzi++;  
}

inline void rubrica_view_dec_indirizzi(void)   
{
  totale_indirizzi--;   
}


